//
// Decompiled with: Decompiler.NET, Version=2.0.0.230, Culture=neutral, PublicKeyToken=null, Version: 2.0.0.230
// Decompilation Started at: 14/02/2008 11:18:44
// Copyright 2003 - 2004, Jungle Creatures, Inc., All Rights Reserved. http://www.junglecreatures.com/
// Written by Jonathan Pierce, Email: support@junglecreatures.com
//

namespace LanmarkControls.CommonInteropLib.PInvoke

{
		
		#region Namespace Import Declarations
		
			using System;
			using System.Collections;
			using System.Runtime.InteropServices;
			using System.Text;
			
		#endregion
		
	public sealed class RegistryKey : MarshalByRefObject, IDisposable
	
	{
		
		#region Fields
			private const int ERROR_NO_MORE_ITEMS = 259;
			private uint m_handle;
			private bool m_isroot;
			private string m_name;
			private bool m_writable;
		#endregion
		
		#region Nested Types
		
			private enum KeyType
			
			{
				String = 1, 
				ExpandString = 2, 
				Binary = 3, 
				DWord = 4, 
				MultiString = 7, 
			}
			
		#endregion
		
		#region Constructors
		
			internal RegistryKey (uint handle, string name, bool writable, bool isroot)
			
			{
				this.m_handle = handle;
				this.m_name = name;
				this.m_writable = writable;
				this.m_isroot = isroot;
			}
			
		#endregion
		
		#region Properties
		
			public string Name
			
			{
				get
				{
					return this.m_name;
				}
			}
			
			
			public int SubKeyCount
			
			{
				get
				{
					int i1;
					int i2;
					int i3;
					int i4;
					int i5;
					int i6;
					char[] charArray1;
					int i7;
					if (this.CheckHKey ())
					{
						charArray1 = new char[256];
						i7 = charArray1.Length;
						if (RegistryKey.RegQueryInfoKey (this.m_handle, charArray1, ref i7, 0, out i1, out i3, out i4, out i2, out i5, out i6, 
						0, 0) == 0)
						{
							return i1;
						}
						else
						{
							throw new ExternalException ("Error retrieving registry properties");
						}
					}
					throw new ObjectDisposedException ("The RegistryKey being manipulated is closed (closed keys cannot be accessed).");
				}
			}
			
			
			public int ValueCount
			
			{
				get
				{
					int i1;
					int i2;
					int i3;
					int i4;
					int i5;
					int i6;
					char[] charArray1;
					int i7;
					if (this.CheckHKey ())
					{
						charArray1 = new char[256];
						i7 = charArray1.Length;
						if (RegistryKey.RegQueryInfoKey (this.m_handle, charArray1, ref i7, 0, out i1, out i3, out i4, out i2, out i5, out i6, 
						0, 0) == 0)
						{
							return i2;
						}
						else
						{
							throw new ExternalException ("Error retrieving registry properties");
						}
					}
					throw new ObjectDisposedException ("The RegistryKey being manipulated is closed (closed keys cannot be accessed).");
				}
			}
			
		#endregion
		
		#region Methods
		
			private bool CheckHKey ()
			
			{
				if (this.m_handle != uint.MinValue)
				{
					return true;
				}
				else
				{
					return false;
				}
			}
			
			public void Close ()
			
			{
				if ((! this.m_isroot) && this.CheckHKey ())
				{
					if (RegistryKey.RegCloseKey (this.m_handle) == 0)
					{
						this.m_handle = uint.MinValue;
					}
					else
					{
						throw new ExternalException ("Error closing RegistryKey");
					}
				}
			}
			
			public RegistryKey CreateSubKey (string subkey)
			
			{
				uint uInt32_1;
				uint uInt32_2;
				if (this.CheckHKey ())
				{
					if (subkey == null)
					{
						throw new ArgumentNullException ("The specified subkey is null.");
					}
					else
					{
						if (subkey.Length < 256)
						{
							uInt32_1 = uint.MinValue;
							uInt32_2 = uint.MinValue;
							if (RegistryKey.RegCreateKeyEx (this.m_handle, subkey, 0, ((string) null), 0, 0, IntPtr.Zero, ref uInt32_1, ref uInt32_2) == 0)
							{
								return new RegistryKey (uInt32_1, (this.m_name + "\\" + subkey), this.m_writable, false);
							}
							else
							{
								throw new ExternalException ("An error occured creating the registry key.");
							}
						}
						throw new ArgumentException ("The length of the specified subkey is longer than the maximum length allowed (25"
						+ "5 characters).");
					}
				}
				throw new ObjectDisposedException ("The RegistryKey on which this method is being invoked is closed (closed keys can"
				+ "not be accessed).");
			}
			
			public void DeleteSubKey (string subkey)
			
			{
				this.DeleteSubKey (subkey, true);
			}
			
			public void DeleteSubKey (string subkey, bool throwOnMissingSubKey)
			
			{
				if ((subkey == null) || (subkey == ""))
				{
					throw new ArgumentNullException ("The subkey is null");
				}
				else
				{
					if (this.CheckHKey ())
					{
						if ((RegistryKey.RegDeleteKey (this.m_handle, subkey) == 0) || (! throwOnMissingSubKey))
						{
							return;
						}
						else
						{
							throw new ArgumentException ("The specified subkey is not a valid reference to a registry key");
						}
					}
					throw new ObjectDisposedException ("The RegistryKey on which this method is being invoked is closed (closed keys can"
					+ "not be accessed).");
				}
			}
			
			public void DeleteSubKeyTree (string subkey)
			
			{
				this.DeleteSubKey (subkey, true);
			}
			
			public void DeleteValue (string name)
			
			{
				this.DeleteValue (name, true);
			}
			
			public void DeleteValue (string name, bool throwOnMissingValue)
			
			{
				if (this.m_writable)
				{
					if (! this.CheckHKey ())
					{
						throw new ObjectDisposedException ("The RegistryKey being manipulated is closed (closed keys cannot be accessed).");
					}
					else
					{
						if (name != null)
						{
							if ((RegistryKey.RegDeleteValue (this.m_handle, name) != 87) || (! throwOnMissingValue))
							{
								return;
							}
							else
							{
								throw new ArgumentException ("name is not a valid reference to a value (and throwOnMissingValue is true) or na"
								+ "me is null");
							}
						}
						throw new ArgumentException ("name is null");
					}
				}
				throw new UnauthorizedAccessException ("Cannot delete a value from a RegistryKey opened as ReadOnly.");
			}
			
			public void Dispose ()
			
			{
				this.Close ();
			}
			
			public void Flush ()
			
			{
				int i1 = RegistryKey.RegFlushKey (this.m_handle);
			}
			
			public string[] GetSubKeyNames ()
			
			{
				int i1;
				ArrayList arrayList1;
				int i2;
				char[] charArray1;
				int i3;
				if (this.CheckHKey ())
				{
					arrayList1 = new ArrayList ();
					i2 = 0;
					charArray1 = new char[256];
					i3 = charArray1.Length;
					for (i1 = RegistryKey.RegEnumKeyEx (this.m_handle, i2, charArray1, ref i3, 0, ((byte[]) null), 0, 0); (i1 != 259); i1 = RegistryKey.RegEnumKeyEx (this.m_handle, i2, charArray1, ref i3, 0, ((byte[]) null), 0, 0))
					{
						int i4 = arrayList1.Add (new string (charArray1, 0, i3));
						i2++;
						i3 = charArray1.Length;
					}
					arrayList1.Sort ();
					return ((string[]) arrayList1.ToArray (typeof (string)));
				}
				else
				{
					throw new ObjectDisposedException ("The RegistryKey being manipulated is closed (closed keys cannot be accessed).");
				}
			}
			
			public object GetValue (string name, object defaultValue)
			
			{
				KeyType keyType1;
				byte[] byteArray1;
				int i1;
				int i2;
				string string1;
				if (this.CheckHKey ())
				{
					keyType1 =  ((KeyType) 0);
					i1 = 0;
					i2 = RegistryKey.RegQueryValueEx (this.m_handle, name, 0, ref keyType1, ((byte[]) null), ref i1);
					if (i2 != 87)
					{
						byteArray1 = new byte[i1];
						i2 = RegistryKey.RegQueryValueEx (this.m_handle, name, 0, ref keyType1, byteArray1, ref i1);
						switch (keyType1)
						{
							case KeyType.String:
							case KeyType.ExpandString:
							
							{
									return Encoding.Unicode.GetString (byteArray1, 0, i1).TrimEnd (new char[1]);
							}
							case KeyType.Binary:
							
							{
									return byteArray1;
							}
							case KeyType.DWord:
							
							{
									return BitConverter.ToUInt32 (byteArray1, 0);
							}
							case  ((KeyType) 5):
							case  ((KeyType) 6):
							
							{
									return defaultValue;
							}
							case KeyType.MultiString:
							
							{
									string1 = Encoding.Unicode.GetString (byteArray1, 0, i1).TrimEnd (new char[1]);
									return string1.Split (new char[1]);
							}
						}
					}
					return defaultValue;
				}
				else
				{
					throw new ObjectDisposedException ("The RegistryKey being manipulated is closed (closed keys cannot be accessed).");
				}
			}
			
			public object GetValue (string name)
			
			{
				return this.GetValue (name, null);
			}
			
			public string[] GetValueNames ()
			
			{
				int i1;
				ArrayList arrayList1;
				int i2;
				char[] charArray1;
				int i3;
				if (this.CheckHKey ())
				{
					arrayList1 = new ArrayList ();
					i2 = 0;
					charArray1 = new char[256];
					i3 = charArray1.Length;
					for (i1 = RegistryKey.RegEnumValue (this.m_handle, i2, charArray1, ref i3, 0, 0, ((byte[]) null), 0); (i1 != 259); i1 = RegistryKey.RegEnumValue (this.m_handle, i2, charArray1, ref i3, 0, 0, ((byte[]) null), 0))
					{
						int i4 = arrayList1.Add (new string (charArray1, 0, i3));
						i2++;
						i3 = charArray1.Length;
					}
					arrayList1.Sort ();
					return ((string[]) arrayList1.ToArray (typeof (string)));
				}
				else
				{
					throw new ObjectDisposedException ("The RegistryKey being manipulated is closed (closed keys cannot be accessed).");
				}
			}
			
			public RegistryKey OpenSubKey (string name, bool writable)
			
			{
				uint uInt32_1;
				if (this.CheckHKey ())
				{
					if (name == null)
					{
						throw new ArgumentNullException ("name is null.");
					}
					else
					{
						if (name.Length < 256)
						{
							uInt32_1 = uint.MinValue;
							if (RegistryKey.RegOpenKeyEx (this.m_handle, name, 0, 0, ref uInt32_1) != 0)
							{
								return null;
							}
							else
							{
								return new RegistryKey (uInt32_1, (this.m_name + "\\" + name), writable, false);
							}
						}
						throw new ArgumentException ("The length of the specified subkey is longer than the maximum length allowed (25"
						+ "5 characters).");
					}
				}
				throw new ObjectDisposedException ("The RegistryKey being manipulated is closed (closed keys cannot be accessed).");
			}
			
			public RegistryKey OpenSubKey (string name)
			
			{
				return this.OpenSubKey (name, false);
			}
			
			[DllImportAttribute("coredll.dll", EntryPoint = "RegCloseKey", CharSet = CharSet.None, ExactSpelling = false, SetLastError = true, PreserveSig = true, CallingConvention = CallingConvention.Winapi, BestFitMapping = false, ThrowOnUnmappableChar = false)]
			[PreserveSigAttribute()]
			private static extern int RegCloseKey (uint hKey);
			[DllImportAttribute("coredll.dll", EntryPoint = "RegCreateKeyEx", CharSet = CharSet.None, ExactSpelling = false, SetLastError = true, PreserveSig = true, CallingConvention = CallingConvention.Winapi, BestFitMapping = false, ThrowOnUnmappableChar = false)]
			[PreserveSigAttribute()]
			private static extern int RegCreateKeyEx (uint hKey, string lpSubKey, int lpReserved, string lpClass, int dwOptions, int samDesired, IntPtr lpSecurityAttributes, ref uint phkResult, ref uint lpdwDisposition);
			[DllImportAttribute("coredll.dll", EntryPoint = "RegDeleteKey", CharSet = CharSet.None, ExactSpelling = false, SetLastError = true, PreserveSig = true, CallingConvention = CallingConvention.Winapi, BestFitMapping = false, ThrowOnUnmappableChar = false)]
			[PreserveSigAttribute()]
			private static extern int RegDeleteKey (uint hKey, string keyName);
			[DllImportAttribute("coredll.dll", EntryPoint = "RegDeleteValue", CharSet = CharSet.None, ExactSpelling = false, SetLastError = true, PreserveSig = true, CallingConvention = CallingConvention.Winapi, BestFitMapping = false, ThrowOnUnmappableChar = false)]
			[PreserveSigAttribute()]
			private static extern int RegDeleteValue (uint hKey, string valueName);
			[DllImportAttribute("coredll.dll", EntryPoint = "RegEnumKeyEx", CharSet = CharSet.None, ExactSpelling = false, SetLastError = true, PreserveSig = true, CallingConvention = CallingConvention.Winapi, BestFitMapping = false, ThrowOnUnmappableChar = false)]
			[PreserveSigAttribute()]
			private static extern int RegEnumKeyEx (uint hKey, int iIndex, char[] sKeyName, ref int iKeyNameLen, int iReservedZero, byte[] sClassName, int iClassNameLenZero, int iFiletimeZero);
			[DllImportAttribute("coredll.dll", EntryPoint = "RegEnumValue", CharSet = CharSet.None, ExactSpelling = false, SetLastError = true, PreserveSig = true, CallingConvention = CallingConvention.Winapi, BestFitMapping = false, ThrowOnUnmappableChar = false)]
			[PreserveSigAttribute()]
			private static extern int RegEnumValue (uint hKey, int iIndex, char[] sValueName, ref int iValueNameLen, int iReservedZero, int iTypeZero, byte[] byData, int iDataLenZero);
			[DllImportAttribute("coredll.dll", EntryPoint = "RegFlushKey", CharSet = CharSet.None, ExactSpelling = false, SetLastError = true, PreserveSig = true, CallingConvention = CallingConvention.Winapi, BestFitMapping = false, ThrowOnUnmappableChar = false)]
			[PreserveSigAttribute()]
			private static extern int RegFlushKey (uint hKey);
			[DllImportAttribute("coredll.dll", EntryPoint = "RegOpenKeyEx", CharSet = CharSet.None, ExactSpelling = false, SetLastError = true, PreserveSig = true, CallingConvention = CallingConvention.Winapi, BestFitMapping = false, ThrowOnUnmappableChar = false)]
			[PreserveSigAttribute()]
			private static extern int RegOpenKeyEx (uint hKey, string lpSubKey, int ulOptions, int samDesired, ref uint phkResult);
			[DllImportAttribute("coredll.dll", EntryPoint = "RegQueryInfoKey", CharSet = CharSet.None, ExactSpelling = false, SetLastError = true, PreserveSig = true, CallingConvention = CallingConvention.Winapi, BestFitMapping = false, ThrowOnUnmappableChar = false)]
			[PreserveSigAttribute()]
			private static extern int RegQueryInfoKey (uint hKey, char[] lpClass, ref int lpcbClass, int reservedZero, [Out] out int cSubkey, [Out] out int iMaxSubkeyLen, [Out] out int lpcbMaxSubkeyClassLen, [Out] out int cValueNames, [Out] out int iMaxValueNameLen, [Out] out int iMaxValueLen, int securityDescriptorZero, int lastWriteTimeZero);
			[DllImportAttribute("coredll.dll", EntryPoint = "RegQueryValueEx", CharSet = CharSet.None, ExactSpelling = false, SetLastError = true, PreserveSig = true, CallingConvention = CallingConvention.Winapi, BestFitMapping = false, ThrowOnUnmappableChar = false)]
			[PreserveSigAttribute()]
			private static extern int RegQueryValueEx (uint hKey, string lpValueName, int lpReserved, ref KeyType lpType, byte[] lpData, ref int lpcbData);
			[DllImportAttribute("coredll.dll", EntryPoint = "RegSetValueExW", CharSet = CharSet.None, ExactSpelling = false, SetLastError = true, PreserveSig = true, CallingConvention = CallingConvention.Winapi, BestFitMapping = false, ThrowOnUnmappableChar = false)]
			[PreserveSigAttribute()]
			private static extern int RegSetValueEx (uint hKey, string lpValueName, int lpReserved, KeyType lpType, byte[] lpData, int lpcbData);
			public void SetValue (string name, object value)
			
			{
				KeyType keyType1;
				byte[] byteArray1;
				StringBuilder stringBuilder1;
				int i1;
				string string2;
				string[] stringArray1;
				if (! this.m_writable)
				{
					throw new UnauthorizedAccessException ("Cannot set value on RegistryKey which was opened as ReadOnly");
				}
				if (! this.CheckHKey ())
				{
					throw new ObjectDisposedException ("The RegistryKey being manipulated is closed (closed keys cannot be accessed).");
				}
				keyType1 =  ((KeyType) 0);
				if ((string2 = value.GetType ().ToString ()) != null)
				{
					string2 = string.IsInterned (string2);
					switch (string2)
					{
						case "System.String":
						
						{
								keyType1 = KeyType.String;
								byteArray1 = Encoding.Unicode.GetBytes ((((string) value) + '\0'.ToString ()));
								goto L_013C;
						}
						case "System.String[]":
						
						{
								stringBuilder1 = new StringBuilder ();
								stringArray1 = ((string[]) value);
								foreach (string string1 in stringArray1)
								{
									StringBuilder stringBuilder2 = stringBuilder1.Append ((string1 + '\0'.ToString ()));
								}
								StringBuilder stringBuilder3 = stringBuilder1.Append ('\0');
								keyType1 = KeyType.MultiString;
								byteArray1 = Encoding.Unicode.GetBytes (stringBuilder1.ToString ());
								goto L_013C;
						}
						case "System.Byte[]":
						
						{
								keyType1 = KeyType.Binary;
								byteArray1 = ((byte[]) value);
								goto L_013C;
						}
						case "System.Int32":
						
						{
								keyType1 = KeyType.DWord;
								byteArray1 = BitConverter.GetBytes (((int) value));
								goto L_013C;
						}
						case "System.UInt32":
						
						{
								keyType1 = KeyType.DWord;
								byteArray1 = BitConverter.GetBytes (((uint) value));
								goto L_013C;
						}
					}
				}
				throw new ArgumentException ("value is not a supported type");
				
			L_013C:
				
				{
				}
				i1 = byteArray1.Length;
				if (RegistryKey.RegSetValueEx (this.m_handle, name, 0, keyType1, byteArray1, i1) != 0)
				{
					throw new ExternalException ("Error writing to the RegistryKey");
				}
			}
			
			public override string ToString ()
			
			{
				if (this.CheckHKey ())
				{
					return (this.m_name + " [0x" + this.m_handle.ToString ("X") + "]");
				}
				else
				{
					throw new ObjectDisposedException ("The RegistryKey being manipulated is closed (closed keys cannot be accessed).");
				}
			}
			
		#endregion
	}
	
}

