//
// Decompiled with: Decompiler.NET, Version=2.0.0.230, Culture=neutral, PublicKeyToken=null, Version: 2.0.0.230
// Decompilation Started at: 14/02/2008 11:19:11
// Copyright 2003 - 2004, Jungle Creatures, Inc., All Rights Reserved. http://www.junglecreatures.com/
// Written by Jonathan Pierce, Email: support@junglecreatures.com
//

namespace LanmarkControls.CommonLib.General

{
		
		#region Namespace Import Declarations
		
			using LanmarkControls.CommonLib.Protocol;
			using System.IO;
			using System;
			using System.Threading;
			
		#endregion
		
	public class AdminSettings
	
	{
		
		#region Fields
			private static ManualResetEvent FileAvailableEvent;
			private static AliveConfigReader m_oAliveSettings;
			private static BroadcastConfigReader m_oBroadcastSettings;
			private static DataConfigData m_oDataSettings;
			private static EventConfigReader m_oEventSettings;
			private static SettingsConfigData m_oOtherSettings;
			private static PriorityConfigReader m_oPrioritySettings;
			private static string m_strBackupFilename;
			private static string m_strFilename;
			private static readonly string m_strFixedDefaultPath;
			private static string m_strFixedPath;
			private static string m_strWinCEFilename;
			private static string xmlCacheString;
		#endregion
		
		#region Constructors
		
			static AdminSettings ()
			
			{
				AdminSettings.m_strFixedPath = "";
				AdminSettings.m_strFixedDefaultPath = "\\LEC\\Config";
				AdminSettings.FileAvailableEvent = new ManualResetEvent (true);
				AdminSettings.m_strFilename = "AdminConfig.xml";
				AdminSettings.m_strWinCEFilename = "AdminConfig_Read.xml";
				AdminSettings.m_strBackupFilename = "AdminConfig_Backup.xml";
				AdminSettings.xmlCacheString = "";
				AdminSettings.m_oBroadcastSettings = ((BroadcastConfigReader) null);
				AdminSettings.m_oOtherSettings = ((SettingsConfigData) null);
				AdminSettings.m_oDataSettings = ((DataConfigData) null);
				AdminSettings.m_oPrioritySettings = ((PriorityConfigReader) null);
				AdminSettings.m_oEventSettings = ((EventConfigReader) null);
				AdminSettings.m_oAliveSettings = ((AliveConfigReader) null);
			}
			
			
			public AdminSettings ()
			
			{
			}
			
		#endregion
		
		#region Properties
		
			public static AliveConfigReader AliveSettings
			
			{
				get
				{
					if (AdminSettings.xmlCacheString == "")
					{
						AdminSettings.BuildFilePath ();
						AdminSettings.GetDataFromFile ();
					}
					if (AdminSettings.m_oAliveSettings == null)
					{
						AdminSettings.m_oAliveSettings = new AliveConfigReader ();
						AdminSettings.m_oAliveSettings.FromXML (AdminSettings.xmlCacheString);
					}
					return AdminSettings.m_oAliveSettings;
				}
			}
			
			
			private static string BackupFilename
			
			{
				get
				{
					return AdminSettings.m_strBackupFilename;
				}
				set
				{
					AdminSettings.m_strBackupFilename = value;
				}
			}
			
			
			public static BroadcastConfigReader BroadcastSettings
			
			{
				get
				{
					if (AdminSettings.xmlCacheString == "")
					{
						AdminSettings.BuildFilePath ();
						AdminSettings.GetDataFromFile ();
					}
					if (AdminSettings.m_oBroadcastSettings == null)
					{
						AdminSettings.m_oBroadcastSettings = new BroadcastConfigReader ();
						AdminSettings.m_oBroadcastSettings.FromXML (AdminSettings.xmlCacheString);
					}
					return AdminSettings.m_oBroadcastSettings;
				}
			}
			
			
			public static DataConfigData DataSettings
			
			{
				get
				{
					if (AdminSettings.xmlCacheString == "")
					{
						AdminSettings.BuildFilePath ();
						AdminSettings.GetDataFromFile ();
					}
					if (AdminSettings.m_oDataSettings == null)
					{
						AdminSettings.m_oDataSettings = new DataConfigData ();
						AdminSettings.m_oDataSettings.FromXML (AdminSettings.xmlCacheString);
					}
					return AdminSettings.m_oDataSettings;
				}
			}
			
			
			private static string DefaultFilename
			
			{
				get
				{
					return AdminSettings.m_strFilename;
				}
				set
				{
					AdminSettings.m_strFilename = value;
				}
			}
			
			
			public static EventConfigReader EventSettings
			
			{
				get
				{
					if (AdminSettings.xmlCacheString == "")
					{
						AdminSettings.BuildFilePath ();
						AdminSettings.GetDataFromFile ();
					}
					if (AdminSettings.m_oEventSettings == null)
					{
						AdminSettings.m_oEventSettings = new EventConfigReader ();
						AdminSettings.m_oEventSettings.FromXML (AdminSettings.xmlCacheString);
					}
					return AdminSettings.m_oEventSettings;
				}
			}
			
			
			public static SettingsConfigData OtherSettings
			
			{
				get
				{
					if (AdminSettings.xmlCacheString == "")
					{
						AdminSettings.BuildFilePath ();
						AdminSettings.GetDataFromFile ();
					}
					if (AdminSettings.m_oOtherSettings == null)
					{
						AdminSettings.m_oOtherSettings = new SettingsConfigData ();
						AdminSettings.m_oOtherSettings.FromXML (AdminSettings.xmlCacheString);
					}
					return AdminSettings.m_oOtherSettings;
				}
			}
			
			
			public static string PathFilename
			
			{
				get
				{
					return Path.Combine (AdminSettings.m_strFixedPath, AdminSettings.DefaultFilename);
				}
			}
			
			
			public static PriorityConfigReader PrioritySettings
			
			{
				get
				{
					if (AdminSettings.xmlCacheString == "")
					{
						AdminSettings.BuildFilePath ();
						AdminSettings.GetDataFromFile ();
					}
					if (AdminSettings.m_oPrioritySettings == null)
					{
						AdminSettings.m_oPrioritySettings = new PriorityConfigReader ();
						AdminSettings.m_oPrioritySettings.FromXML (AdminSettings.xmlCacheString);
					}
					return AdminSettings.m_oPrioritySettings;
				}
			}
			
			
			private static string WinCEFilename
			
			{
				get
				{
					return AdminSettings.m_strWinCEFilename;
				}
				set
				{
					AdminSettings.m_strWinCEFilename = value;
				}
			}
			
		#endregion
		
		#region Methods
		
			private static void BuildFilePath ()
			
			{
				if (CommonSvrUtil.PermFlashStoragePath.Length > 0)
				{
					AdminSettings.m_strFixedPath = ("\\" + CommonSvrUtil.PermFlashStoragePath + AdminSettings.m_strFixedDefaultPath);
				}
				else
				{
					AdminSettings.m_strFixedPath = AdminSettings.m_strFixedDefaultPath;
				}
			}
			
			private static void ClearCache ()
			
			{
				AdminSettings.xmlCacheString = "";
				AdminSettings.m_oBroadcastSettings = ((BroadcastConfigReader) null);
				AdminSettings.m_oOtherSettings = ((SettingsConfigData) null);
				AdminSettings.m_oDataSettings = ((DataConfigData) null);
				AdminSettings.m_oPrioritySettings = ((PriorityConfigReader) null);
				AdminSettings.m_oEventSettings = ((EventConfigReader) null);
				AdminSettings.m_oAliveSettings = ((AliveConfigReader) null);
			}
			
			private static void FindAdminFile ()
			
			{
				string string1;
				int i1;
				FileInfo fileInfo1;
				string string2;
				FileInfo fileInfo2;
				string string3;
				FileInfo fileInfo3;
				Exception exception1;
				try
				{
					string1 = Path.Combine (AdminSettings.m_strFixedPath, AdminSettings.DefaultFilename);
					i1 = 100;
					
				L_0013:
					
					{
					}
					fileInfo1 = new FileInfo (string1);
					if (fileInfo1.Exists && (fileInfo1.Length > ((long) 0)))
					{
						return;
					}
					else
					{
						Thread.Sleep (10);
						if (i1-- > 0)
						{
							goto L_0013;
						}
						else
						{
							string2 = Path.Combine (AdminSettings.m_strFixedPath, AdminSettings.WinCEFilename);
							fileInfo2 = new FileInfo (string2);
							if (fileInfo2.Exists)
							{
								FileInfo fileInfo4 = fileInfo2.CopyTo (string1, true);
								fileInfo2.Delete ();
								return;
							}
							else
							{
								string3 = Path.Combine (AdminSettings.m_strFixedPath, AdminSettings.BackupFilename);
								fileInfo3 = new FileInfo (string3);
								if (fileInfo3.Exists)
								{
									FileInfo fileInfo5 = fileInfo3.CopyTo (string1, true);
									return;
								}
								else
								{
									throw new Exception ("Exception: AdminConfig_Backup.xml not found");
								}
							}
						}
					}
				}
				catch (Exception exception2)
				{
					exception1 = exception2;
					Logging.Instance.Log (0, ("AdminSettings.FindAdminFile()  - Exception 0x03d  " + exception1.Message));
					Logging.Instance.Log (0, exception1.ToString ());
				}
			}
			
			private static void GetDataFromFile ()
			
			{
				AdminSettings.FindAdminFile ();
				AdminSettings.ClearCache ();
				string string1 = Path.Combine (AdminSettings.m_strFixedPath, AdminSettings.DefaultFilename);
				if (! File.Exists (string1))
				{
					return;
				}
				bool b1 = AdminSettings.FileAvailableEvent.WaitOne ();
				bool b2 = AdminSettings.FileAvailableEvent.Reset ();
				StreamReader streamReader1 = new StreamReader (string1);
				AdminSettings.xmlCacheString = streamReader1.ReadToEnd ();
				streamReader1.Close ();
				bool b3 = AdminSettings.FileAvailableEvent.Set ();
			}
			
			public static void UpdateAdminDataChannel (DataConfigData settingsData)
			
			{
				AdminSettings.ClearCache ();
				bool b1 = AdminSettings.FileAvailableEvent.WaitOne ();
				bool b2 = AdminSettings.FileAvailableEvent.Reset ();
				bool b3 = XmlUtil.UpdateXML (Path.Combine (AdminSettings.m_strFixedPath, AdminSettings.DefaultFilename), "Data,DataChannel", settingsData.ToXML (1));
				bool b4 = AdminSettings.FileAvailableEvent.Set ();
				AdminSettings.GetDataFromFile ();
				bool b5 = AdminSettings.FileAvailableEvent.Set ();
			}
			
			public static void UpdateAdminSettings (SettingsConfigData settingsData)
			
			{
				AdminSettings.ClearCache ();
				bool b1 = AdminSettings.FileAvailableEvent.WaitOne ();
				bool b2 = AdminSettings.FileAvailableEvent.Reset ();
				bool b3 = XmlUtil.UpdateXML (Path.Combine (AdminSettings.m_strFixedPath, AdminSettings.DefaultFilename), "Data,Settings", settingsData.ToXML (1));
				bool b4 = AdminSettings.FileAvailableEvent.Set ();
				AdminSettings.GetDataFromFile ();
				bool b5 = AdminSettings.FileAvailableEvent.Set ();
			}
			
		#endregion
	}
	
}

