//
// Decompiled with: Decompiler.NET, Version=2.0.0.230, Culture=neutral, PublicKeyToken=null, Version: 2.0.0.230
// Decompilation Started at: 14/02/2008 11:19:11
// Copyright 2003 - 2004, Jungle Creatures, Inc., All Rights Reserved. http://www.junglecreatures.com/
// Written by Jonathan Pierce, Email: support@junglecreatures.com
//

namespace LanmarkControls.CommonLib.General

{
		
		#region Namespace Import Declarations
		
			using System.Collections;
			using System.IO;
			using System;
			using System.Text;
			using System.Threading;
			
		#endregion
		
	public class Logging : IDisposable
	
	{
		
		#region Fields
			private const int DisplayByteSize = 16;
			private const string DisplayString = "{0:x2} {1:x2} {2:x2} {3:x2} {4:x2} {5:x2} {6:x2} {7:x2} {8:x2} {9:x2} {10:x2} {1"
			+ "1:x2} {12:x2} {13:x2} {14:x2} {15:x2}";
			private static readonly Logging instanceLogging;
			private bool m_bLogConsole;
			private int m_iLoggingLevel;
			private StreamWriter m_oLog;
			private string m_strLogFile;
			private ArrayList stringArray;
			private object thisLock;
		#endregion
		
		#region Constructors
		
			static Logging ()
			
			{
				Logging.instanceLogging = new Logging ();
			}
			
			
			protected Logging ()
			
			{
				this.thisLock = new object ();
				this.m_iLoggingLevel = 0;
				this.m_strLogFile = "BaseLog.txt";
				this.m_bLogConsole = false;
				this.m_oLog = ((StreamWriter) null);
				this.stringArray = new ArrayList ();
			}
			
		#endregion
		
		#region Properties
		
			public static Logging Instance
			
			{
				get
				{
					return Logging.instanceLogging;
				}
			}
			
			
			public bool LogConsole
			
			{
				get
				{
					return false;
				}
				set
				{
					this.m_bLogConsole = value;
				}
			}
			
			
			public string LogFile
			
			{
				get
				{
					return this.m_strLogFile;
				}
				set
				{
					this.m_strLogFile = value;
				}
			}
			
			
			public int LoggingLevel
			
			{
				get
				{
					return this.m_iLoggingLevel;
				}
				set
				{
					this.m_iLoggingLevel = value;
				}
			}
			
		#endregion
		
		#region Methods
		
			public virtual void Dispose ()
			
			{
				object object1 = this.thisLock;
				lock (object1)
				{
					if (this.m_oLog != null)
					{
						this.m_oLog.Flush ();
						this.m_oLog.Close ();
						this.m_oLog = ((StreamWriter) null);
					}
				}
			}
			
			public void ForceLog ()
			
			{
			}
			
			public void Log (string pstrMessage, int piParameter1, int piParameter2, int piParameter3, int piParameter4)
			
			{
				this.Log (1, pstrMessage, piParameter1, piParameter2, piParameter3, piParameter4);
			}
			
			public void Log (int piLevel, string pstrMessage, int piParameter1, int piParameter2, int piParameter3)
			
			{
				string string1 = string.Format (pstrMessage, piParameter1, piParameter2, piParameter3);
				this.Log (piLevel, string1);
			}
			
			public void Log (string pstrMessage, int piParameter1, int piParameter2, int piParameter3)
			
			{
				this.Log (1, pstrMessage, piParameter1, piParameter2, piParameter3);
			}
			
			public void Log (string pstrMessage)
			
			{
				this.Log (1, pstrMessage);
			}
			
			public void Log (string pstrMessage, int piParameter1, int piParameter2)
			
			{
				this.Log (1, pstrMessage, piParameter1, piParameter2);
			}
			
			public void Log (int piLevel, string pstrMessage, int piParameter1, int piParameter2, int piParameter3, int piParameter4)
			
			{
				object[] objectArray1 = new object[] { piParameter1, piParameter2, piParameter3, piParameter4 };
				string string1 = string.Format (pstrMessage, objectArray1);
				this.Log (piLevel, string1);
			}
			
			public void Log (int piLevel, string pstrMessage, int piParameter1, int piParameter2)
			
			{
				string string1 = string.Format (pstrMessage, piParameter1, piParameter2);
				this.Log (piLevel, string1);
			}
			
			public void Log (string pstrMessage, int piParameter1)
			
			{
				this.Log (1, pstrMessage, piParameter1);
			}
			
			public void Log (int piLevel, string pstrMessage, int piParameter1)
			
			{
				string string1 = string.Format (pstrMessage, piParameter1);
				this.Log (piLevel, string1);
			}
			
			public void Log (int piLevel, string pstrMessage)
			
			{
				Exception exception1;
				object object1;
				string[] stringArray1;
				if ((piLevel <= this.LoggingLevel) && ((this.m_strLogFile.Length != 0) || this.m_bLogConsole))
				{
					try
					{
						if (this.m_strLogFile.Length > 0)
						{
							object1 = this.thisLock;
							lock (object1)
							{
								if (this.m_oLog == null)
								{
									this.m_oLog = new StreamWriter (this.m_strLogFile, true);
									this.m_oLog.AutoFlush = true;
								}
								stringArray1 = new string[] { Environment.TickCount.ToString (), ":", Thread.CurrentThread.GetHashCode ().ToString (), " ", pstrMessage };
								this.m_oLog.WriteLine (string.Concat (stringArray1));
							}
						}
						if (this.m_bLogConsole)
						{
							stringArray1 = new string[] { Environment.TickCount.ToString (), ":", Thread.CurrentThread.GetHashCode ().ToString (), " ", pstrMessage };
							Console.WriteLine (string.Concat (stringArray1));
						}
					}
					catch (Exception exception2)
					{
						exception1 = exception2;
						this.Dispose ();
						if (this.m_bLogConsole)
						{
							if (this.m_strLogFile.Length > 0)
							{
								Console.WriteLine (("Attempting to log to " + this.m_strLogFile + " failed. Exception thrown."));
							}
							Console.WriteLine (("Logging.Log - Exception 0x03d " + exception1.Message));
						}
					}
				}
			}
			
			public void LogBytes (byte[] pbyteData, int piStart, int piLength)
			
			{
				this.LogBytes (1, pbyteData, piStart, piLength);
			}
			
			public void LogBytes (int piLevel, byte[] pbyteData, int piStart, int piLength)
			
			{
				int i1;
				StringBuilder stringBuilder1;
				object[] objectArray1;
				int i2;
				int i3;
				string string1;
				int i4;
				Exception exception1;
				string[] stringArray1;
				if ((piLevel <= this.LoggingLevel) && ((this.m_strLogFile.Length != 0) || this.m_bLogConsole))
				{
					try
					{
						if (((this.m_strLogFile.Length > 0) && (this.m_oLog == null)) && (piLevel == 0))
						{
							this.m_oLog = new StreamWriter (this.m_strLogFile, true);
							this.m_oLog.AutoFlush = true;
						}
						i1 = 0;
						stringBuilder1 = new StringBuilder (piLength);
						if ((this.m_oLog != null) && (piLevel == 0))
						{
							stringArray1 = new string[] { DateTime.Now.ToString (), ":", Thread.CurrentThread.GetHashCode ().ToString (), " Data size 0x03d ", piLength.ToString (), ":" };
							this.m_oLog.WriteLine (string.Concat (stringArray1));
						}
						if (this.m_bLogConsole)
						{
							stringArray1 = new string[] { DateTime.Now.ToString (), Thread.CurrentThread.GetHashCode ().ToString (), " Data size 0x03d ", piLength.ToString (), ":" };
							Console.WriteLine (string.Concat (stringArray1));
						}
						objectArray1 = new object[16];
						i2 = piStart;
						
					L_027D:
						
						{
						}
						if (i2 < (piStart + piLength))
						{
							if ((i2 + 16) >= (piStart + piLength))
							{
								objectArray1 = new object[((piStart + piLength) - i2)];
								string1 = "{0:x2}";
								objectArray1[0] = ((int) pbyteData[i2]);
								for (i4 = (i2 + 1); (i4 < (piStart + piLength)); i4++)
								{
									string1 = (string1 + " {" + (i4 - i2).ToString () + ":x2}");
									objectArray1[(i4 - i2)] = ((int) pbyteData[i4]);
								}
								StringBuilder stringBuilder3 = stringBuilder1.Append (string.Format (("                " + string1 + ((this.m_oLog != null) ? this.m_oLog.NewLine : "\r\n")), objectArray1));
							}
							else
							{
								for (i3 = 0; (i3 < 16); i3++)
								{
									objectArray1[i3] = ((int) pbyteData[(i2 + i3)]);
								}
								StringBuilder stringBuilder2 = stringBuilder1.Append (string.Format (("                {0:x2} {1:x2} {2:x2} {3:x2} {4:x2} {5:x2} {6:x2} {7:x2} {8:x2} {"
								+ "9:x2} {10:x2} {11:x2} {12:x2} {13:x2} {14:x2} {15:x2}" + ((this.m_oLog != null) ? this.m_oLog.NewLine : "\r\n")), objectArray1));
							}
							if (stringBuilder1.Length >= piLength)
							{
								if (this.m_oLog != null)
								{
									this.m_oLog.Write (stringBuilder1.ToString ());
								}
								if (this.m_bLogConsole)
								{
									Console.Write (stringBuilder1.ToString ());
								}
								stringBuilder1 = new StringBuilder (piLength);
							}
							i2 += 16;
							goto L_027D;
						}
						else
						{
							if (stringBuilder1.Length > 0)
							{
								if (this.m_oLog != null)
								{
									this.m_oLog.Write (stringBuilder1.ToString ());
								}
								if (this.m_bLogConsole)
								{
									Console.Write (stringBuilder1.ToString ());
								}
							}
							if (i1 != 0)
							{
								if (this.m_oLog != null)
								{
									this.m_oLog.WriteLine ();
								}
								if (this.m_bLogConsole)
								{
									Console.WriteLine ();
								}
							}
						}
					}
					catch (Exception exception2)
					{
						exception1 = exception2;
						if (this.m_bLogConsole)
						{
							if (this.m_strLogFile.Length > 0)
							{
								Console.WriteLine (("Attempting to log to " + this.m_strLogFile + " failed. Exception thrown."));
							}
							Console.WriteLine (("Logging.LogBytes - Exception 0x03d " + exception1.Message));
						}
					}
				}
			}
			
			public void LogTemp (int piLevel, string opCode, int intValue)
			
			{
				if (piLevel <= this.LoggingLevel)
				{
					this.LogTemp (opCode, intValue);
				}
			}
			
			public void LogTemp (string opCode, int intValue)
			
			{
				int i1 = this.stringArray.Add ((opCode + ":  " + intValue.ToString ()));
			}
			
		#endregion
	}
	
}

