//
// Decompiled with: Decompiler.NET, Version=2.0.0.230, Culture=neutral, PublicKeyToken=null, Version: 2.0.0.230
// Decompilation Started at: 14/02/2008 11:19:11
// Copyright 2003 - 2004, Jungle Creatures, Inc., All Rights Reserved. http://www.junglecreatures.com/
// Written by Jonathan Pierce, Email: support@junglecreatures.com
//

namespace LanmarkControls.CommonLib.General

{
		
		#region Namespace Import Declarations
		
			using System;
			using System.Reflection;
			
		#endregion
		
	// [DefaultMemberAttribute("Item")]
	public class Matrix
	
	{
		
		#region Fields
			private double[] m_dC;
		#endregion
		
		#region Constructors
		
			public Matrix ()
			
			{
				this.m_dC = new double[9];
				Array.Clear (((Array) this.m_dC), 0, 9);
			}
			
		#endregion
		
		#region Properties
		
			public double A
			
			{
				get
				{
					return this.m_dC[0];
				}
			}
			
			
			public double B
			
			{
				get
				{
					return this.m_dC[1];
				}
			}
			
			
			public double C
			
			{
				get
				{
					return this.m_dC[3];
				}
			}
			
			
			public double D
			
			{
				get
				{
					return this.m_dC[4];
				}
			}
			
			
			public double this[int index]
			
			{
				get
				{
					return this.m_dC[index];
				}
				set
				{
					this.m_dC[index] = value;
				}
			}
			
			
			public double Xo
			
			{
				get
				{
					return this.m_dC[2];
				}
			}
			
			
			public double Yo
			
			{
				get
				{
					return this.m_dC[5];
				}
			}
			
		#endregion
		
		#region Methods
		
			public Point3D ApplyTransform (Point3D poPt)
			
			{
				Point3D point3D1 = new Point3D (0D, 0D, 0D);
				point3D1.X = (((this.m_dC[0] * poPt.X) + (this.m_dC[1] * poPt.Y)) + this.m_dC[2]);
				point3D1.Y = (((this.m_dC[3] * poPt.X) + (this.m_dC[4] * poPt.Y)) + this.m_dC[5]);
				return point3D1;
			}
			
			public bool IsIdentity ()
			
			{
				if (this.m_dC[0] != 1D)
				{
					return false;
				}
				else if (this.m_dC[1] != 0D)
				{
					return false;
				}
				else if (this.m_dC[2] != 0D)
				{
					return false;
				}
				else if (this.m_dC[3] != 0D)
				{
					return false;
				}
				else if (this.m_dC[4] != 1D)
				{
					return false;
				}
				else if (this.m_dC[5] != 0D)
				{
					return false;
				}
				else if (this.m_dC[6] != 0D)
				{
					return false;
				}
				else if (this.m_dC[7] != 0D)
				{
					return false;
				}
				else if (this.m_dC[8] != 1D)
				{
					return false;
				}
				else
				{
					return true;
				}
			}
			
			public void ModifyMatrix (double pdScaleX, double pdScaleY, double pdOffsetX, double pdOffsetY, double pdRotation)
			
			{
				double double3;
				Array.Clear (((Array) this.m_dC), 0, 9);
				double double1 = 1D;
				double double2 = 0D;
				if (pdRotation == 90D)
				{
					double1 = 0D;
					double2 = 1D;
				}
				else if (pdRotation == 180D)
				{
					double1 = -1D;
					double2 = 0D;
				}
				else if (pdRotation == 270D)
				{
					double1 = 0D;
					double2 = -1D;
				}
				else if (pdRotation > 0D)
				{
					double3 = (pdRotation * 0.017453292519943295D);
					double1 = Math.Cos (double3);
					double2 = Math.Sin (double3);
				}
				this.m_dC[0] = (pdScaleX * double1);
				this.m_dC[1] = (pdScaleY * double2);
				this.m_dC[2] = pdOffsetX;
				this.m_dC[3] = (pdScaleX * (- double2));
				this.m_dC[4] = (pdScaleY * double1);
				this.m_dC[5] = pdOffsetY;
				this.m_dC[8] = 1D;
			}
			
			public static Matrix operator * (Matrix poSource1, Matrix poSource2)
			
			{
				int i1;
				int i2;
				int i3;
				Matrix matrix1 = new Matrix ();
				for (i1 = 0; (i1 < 3); i1++)
				{
					for (i2 = 0; (i2 < 3); i2++)
					{
						for (i3 = 0; (i3 < 3); i3++)
						{
							matrix1[((int) ((3 * i1) + i2))] = (matrix1[((int) ((3 * i1) + i2))] + (poSource1[((int) ((3 * i3) + i2))] * poSource2[((int) ((3 * i1) + i3))]));
						}
					}
				}
				return matrix1;
			}
			
			public void SetMatrix (double A, double B, double C, double D, double Xo, double Yo)
			
			{
				Array.Clear (((Array) this.m_dC), 0, 9);
				this.m_dC[0] = A;
				this.m_dC[1] = B;
				this.m_dC[2] = Xo;
				this.m_dC[3] = C;
				this.m_dC[4] = D;
				this.m_dC[5] = Yo;
			}
			
			public void SetMatrix (double[] affineTransform)
			
			{
				Array.Clear (((Array) this.m_dC), 0, 9);
				this.m_dC[0] = affineTransform[0];
				this.m_dC[1] = affineTransform[1];
				this.m_dC[2] = affineTransform[4];
				this.m_dC[3] = affineTransform[2];
				this.m_dC[4] = affineTransform[3];
				this.m_dC[5] = affineTransform[5];
			}
			
			public void SetToIdentity ()
			
			{
				Array.Clear (((Array) this.m_dC), 0, 9);
				this.m_dC[0] = 1D;
				this.m_dC[4] = 1D;
				this.m_dC[8] = 1D;
			}
			
			public Matrix SetToInverse ()
			
			{
				double double1 = (1D / (((this.m_dC[0] * ((this.m_dC[4] * this.m_dC[8]) - (this.m_dC[5] * this.m_dC[7]))) - (this.m_dC[1] * ((this.m_dC[3] * this.m_dC[8]) - (this.m_dC[5] * this.m_dC[6])))) + (this.m_dC[2] * ((this.m_dC[3] * this.m_dC[7]) - (this.m_dC[4] * this.m_dC[6])))));
				Matrix matrix1 = new Matrix ();
				matrix1[0] = (double1 * ((this.m_dC[4] * this.m_dC[8]) - (this.m_dC[5] * this.m_dC[7])));
				matrix1[1] = ((- double1) * ((this.m_dC[1] * this.m_dC[8]) - (this.m_dC[2] * this.m_dC[7])));
				matrix1[2] = (double1 * ((this.m_dC[1] * this.m_dC[5]) - (this.m_dC[2] * this.m_dC[4])));
				matrix1[3] = ((- double1) * ((this.m_dC[3] * this.m_dC[8]) - (this.m_dC[5] * this.m_dC[6])));
				matrix1[4] = (double1 * ((this.m_dC[0] * this.m_dC[8]) - (this.m_dC[2] * this.m_dC[6])));
				matrix1[5] = ((- double1) * ((this.m_dC[0] * this.m_dC[5]) - (this.m_dC[2] * this.m_dC[3])));
				matrix1[6] = (double1 * ((this.m_dC[3] * this.m_dC[7]) - (this.m_dC[4] * this.m_dC[6])));
				matrix1[7] = ((- double1) * ((this.m_dC[0] * this.m_dC[7]) - (this.m_dC[1] * this.m_dC[6])));
				matrix1[8] = (double1 * ((this.m_dC[0] * this.m_dC[4]) - (this.m_dC[1] * this.m_dC[3])));
				return matrix1;
			}
			
		#endregion
	}
	
}

