//
// Decompiled with: Decompiler.NET, Version=2.0.0.230, Culture=neutral, PublicKeyToken=null, Version: 2.0.0.230
// Decompilation Started at: 14/02/2008 11:30:26
// Copyright 2003 - 2004, Jungle Creatures, Inc., All Rights Reserved. http://www.junglecreatures.com/
// Written by Jonathan Pierce, Email: support@junglecreatures.com
//

namespace OpenNETCF.Configuration

{
		
		#region Namespace Import Declarations
		
			using System;
			using System.Collections;
			using System.IO;
			using System.Threading;
			using System.Xml;
			
		#endregion
		
	internal class ConfigurationRecord
	
	{
		
		#region Fields
			private Exception error;
			private Hashtable factories;
			private bool factoriesNoInherit;
			private string filename;
			private static object GroupSingleton;
			private readonly ConfigurationRecord parent;
			private static object RemovedFactorySingleton;
			private Hashtable results;
			private Hashtable unevaluatedSections;
		#endregion
		
		#region Nested Types
		
			private enum HaveFactoryEnum
			
			{
				NotFound = 0, 
				Group = 1, 
				Section = 2, 
			}
			
		#endregion
		
		#region Constructors
		
			public ConfigurationRecord ()
				 : this (((ConfigurationRecord) null))
			
			{
			}
			
			
			public ConfigurationRecord (ConfigurationRecord Parent)
			
			{
				this.filename = ((string) null);
				this.parent = ((ConfigurationRecord) null);
				this.results = new Hashtable ();
				this.parent = Parent;
			}
			
			
			static ConfigurationRecord ()
			
			{
				ConfigurationRecord.RemovedFactorySingleton = new object ();
				ConfigurationRecord.GroupSingleton = new object ();
			}
			
		#endregion
		
		#region Properties
		
			private Hashtable EnsureFactories
			
			{
				get
				{
					if (this.factories == null)
					{
						this.factories = new Hashtable ();
					}
					return this.factories;
				}
			}
			
		#endregion
		
		#region Methods
		
			private ConfigurationException BuildConfigError (string message, XmlTextReader reader)
			
			{
				return new ConfigurationException (message, this.filename, reader.LineNumber);
			}
			
			private ConfigurationException BuildConfigError (string message, Exception inner, XmlTextReader reader)
			
			{
				return new ConfigurationException (message, inner, this.filename, reader.LineNumber);
			}
			
			private void CheckForUnrecognizedAttributes (XmlTextReader reader)
			
			{
				if (reader.HasAttributes)
				{
					bool b1 = reader.MoveToNextAttribute ();
					this.ThrowUnrecognizedAttribute (reader);
				}
			}
			
			private void CheckIgnorableNodeType (XmlTextReader reader)
			
			{
				if ((((reader.NodeType != XmlNodeType.Comment) && (reader.NodeType != XmlNodeType.EndElement)) && (reader.NodeType != XmlNodeType.Whitespace)) && (reader.NodeType != XmlNodeType.SignificantWhitespace))
				{
					this.ThrowUnrecognizedElement (reader);
				}
			}
			
			private void CheckRequiredAttribute (object o, string attrName, XmlTextReader reader)
			
			{
				if (o == null)
				{
					this.ThrowRequiredAttribute (reader, "name");
				}
			}
			
			private object Evaluate (string configKey)
			
			{
				Exception exception1;
				IConfigurationSectionHandler iConfigurationSectionHandler1 = this.GetFactory (configKey);
				object object1 = ((this.parent == null) ? null : this.parent.GetConfig (configKey));
				char[] charArray1 = new char[] { '\u002F' };
				string[] stringArray1 = configKey.Split (charArray1);
				XmlTextReader xmlTextReader1 = ((XmlTextReader) null);
				object object2 = null;
				try
				{
					try
					{
						xmlTextReader1 = ConfigurationRecord.OpenXmlTextReader (this.filename);
						object2 = this.EvaluateRecursive (iConfigurationSectionHandler1, object1, stringArray1, 0, xmlTextReader1);
					}
					catch (ConfigurationException)
					{
						throw;
					}
					catch (Exception exception2)
					{
						exception1 = exception2;
						throw this.TranslateXmlParseOrEvaluateErrors (exception1);
					}
				}
				finally
				{
					if (xmlTextReader1 != null)
					{
						xmlTextReader1.Close ();
					}
				}
				if (this.unevaluatedSections.Count == 0)
				{
					this.unevaluatedSections = ((Hashtable) null);
				}
				return object2;
			}
			
			private object EvaluateRecursive (IConfigurationSectionHandler factory, object config, string[] keys, int iKey, XmlTextReader reader)
			
			{
				int i2;
				ConfigXmlDocument configXmlDocument1;
				Exception exception1;
				string string1 = keys[iKey];
				int i1 = reader.Depth;
				while (reader.Read () && (reader.NodeType != XmlNodeType.Element))
				{
				}
				while (reader.Depth == (i1 + 1))
				{
					if (reader.Name != string1)
					{
						this.StrictSkipToNextElement (reader);
						continue;
					}
					if (iKey >= (keys.Length - 1))
					{
						i2 = reader.LineNumber;
						try
						{
							configXmlDocument1 = new ConfigXmlDocument ();
							configXmlDocument1.LoadSingleElement (this.filename, reader);
							config = factory.Create (config, null, ((XmlNode) configXmlDocument1.DocumentElement));
							continue;
						}
						catch (ConfigurationException)
						{
							throw;
						}
						catch (XmlException)
						{
							throw;
						}
						catch (Exception exception2)
						{
							exception1 = exception2;
							throw new ConfigurationException ("Exception in ConfigSectionHandler", exception1, this.filename, i2);
						}
					}
					config = this.EvaluateRecursive (factory, config, keys, ((int) (iKey + 1)), reader);
				}
				return config;
			}
			
			public object GetConfig (string configKey)
			
			{
				if (this.error != null)
				{
					throw this.error;
				}
				if (this.results.Contains (configKey))
				{
					return this.results[configKey];
				}
				object object1 = this.ResolveConfig (configKey);
				object object2 = this.results.SyncRoot;
				lock (object2)
				{
					this.results[configKey] = object1;
				}
				return object1;
			}
			
			private IConfigurationSectionHandler GetFactory (string configKey)
			
			{
				object object1;
				IConfigurationSectionHandler iConfigurationSectionHandler1;
				string string1;
				Type type1;
				Exception exception1;
				object object2;
				if ((this.factories != null) && this.factories.Contains (configKey))
				{
					object1 = this.factories[configKey];
					if (object1 == ConfigurationRecord.RemovedFactorySingleton)
					{
						return null;
					}
					else
					{
						iConfigurationSectionHandler1 = (object1 as IConfigurationSectionHandler);
						if (iConfigurationSectionHandler1 != null)
						{
							return iConfigurationSectionHandler1;
						}
						else
						{
							string1 = ((string) object1);
							object1 = null;
							try
							{
								type1 = Type.GetType (string1);
								if (type1 != null)
								{
									if (! typeof (IConfigurationSectionHandler).IsAssignableFrom (type1))
									{
										throw new ConfigurationException ("Type does not implement IConfigSectionHandler");
									}
									else
									{
										object1 = Activator.CreateInstance (type1);
									}
								}
							}
							catch (Exception exception2)
							{
								exception1 = exception2;
								throw new ConfigurationException (exception1.Message, exception1);
							}
							if (object1 == null)
							{
								throw new ConfigurationException ("Could not create type instance");
							}
							else
							{
								iConfigurationSectionHandler1 = (object1 as IConfigurationSectionHandler);
								if (iConfigurationSectionHandler1 == null)
								{
									throw new ConfigurationException ("Type doesn\'t implement IConfigSectionHandler");
								}
								else
								{
									object2 = this.factories.SyncRoot;
									lock (object2)
									{
										this.factories[configKey] = iConfigurationSectionHandler1;
									}
									return iConfigurationSectionHandler1;
								}
							}
						}
					}
				}
				if (this.factoriesNoInherit)
				{
					return null;
				}
				else if (this.parent == null)
				{
					return null;
				}
				else
				{
					return this.parent.GetFactory (configKey);
				}
			}
			
			private HaveFactoryEnum HaveFactory (string configKey)
			
			{
				object object1;
				if ((this.factories != null) && this.factories.Contains (configKey))
				{
					object1 = this.factories[configKey];
					if (object1 == ConfigurationRecord.RemovedFactorySingleton)
					{
						return HaveFactoryEnum.NotFound;
					}
					else if (object1 != ConfigurationRecord.GroupSingleton)
					{
						return HaveFactoryEnum.Section;
					}
					else
					{
						return HaveFactoryEnum.Group;
					}
				}
				if (this.factoriesNoInherit)
				{
					return HaveFactoryEnum.NotFound;
				}
				else if (this.parent == null)
				{
					return HaveFactoryEnum.NotFound;
				}
				else
				{
					return this.parent.HaveFactory (configKey);
				}
			}
			
			public bool Load (string Filename)
			
			{
				Exception exception1;
				Uri uri1 = new Uri (Filename);
				switch (uri1.Scheme)
				{
					case "file":
					
					{
							this.filename = uri1.LocalPath;
							break;
					}
					default:
					
					{
							this.filename = Filename;
							break;
					}
				}
				XmlTextReader xmlTextReader1 = ((XmlTextReader) null);
				try
				{
					try
					{
						xmlTextReader1 = ConfigurationRecord.OpenXmlTextReader (this.filename);
						if (xmlTextReader1 != null)
						{
							this.ScanFactoriesRecursive (xmlTextReader1);
							if (xmlTextReader1.Depth == 1)
							{
								this.ScanSectionsRecursive (xmlTextReader1, ((string) null));
							}
							return true;
						}
					}
					catch (ConfigurationException)
					{
						throw;
					}
					catch (Exception exception2)
					{
						exception1 = exception2;
						this.error = ((Exception) this.TranslateXmlParseOrEvaluateErrors (exception1));
						throw this.error;
					}
				}
				finally
				{
					if (xmlTextReader1 != null)
					{
						xmlTextReader1.Close ();
					}
				}
				return false;
			}
			
			private static XmlTextReader OpenXmlTextReader (string configFileName)
			
			{
				string string1;
				Stream stream1;
				XmlTextReader xmlTextReader2;
				Uri uri1 = new Uri (configFileName);
				bool b1 = (uri1.Scheme == "file");
				if (b1)
				{
					string1 = uri1.LocalPath;
				}
				else
				{
					string1 = uri1.ToString ();
				}
				XmlTextReader xmlTextReader1 = ((XmlTextReader) null);
				try
				{
					if (! b1)
					{
						try
						{
							stream1 = ((Stream) File.OpenRead (configFileName));
							xmlTextReader1 = new XmlTextReader (stream1);
						}
						catch
						{
							return ((XmlTextReader) null);
						}
					}
					else if (! File.Exists (uri1.LocalPath))
					{
						return ((XmlTextReader) null);
					}
					else
					{
						xmlTextReader1 = new XmlTextReader (string1);
					}
					XmlNodeType xmlNodeType1 = xmlTextReader1.MoveToContent ();
					xmlTextReader2 = xmlTextReader1;
				}
				catch (Exception)
				{
					throw new ConfigurationException ("ErrorloadingXMLfile", string1, 0);
				}
				return xmlTextReader2;
			}
			
			public object ResolveConfig (string configKey)
			
			{
				if ((this.unevaluatedSections != null) && this.unevaluatedSections.Contains (configKey))
				{
					return this.Evaluate (configKey);
				}
				else if (this.parent == null)
				{
					return null;
				}
				else
				{
					return this.parent.GetConfig (configKey);
				}
			}
			
			private void ScanFactoriesRecursive (XmlTextReader reader)
			
			{
				XmlNodeType xmlNodeType1 = reader.MoveToContent ();
				if ((reader.NodeType != XmlNodeType.Element) || (reader.Name != "configuration"))
				{
					throw this.BuildConfigError ((this.filename + " doesn\'t have root configuration"), reader);
				}
				else
				{
					this.CheckForUnrecognizedAttributes (reader);
					this.StrictReadToNextElement (reader);
					if ((reader.Depth == 1) && (reader.Name == "configSections"))
					{
						this.CheckForUnrecognizedAttributes (reader);
						this.ScanFactoriesRecursive (reader, ((string) null));
					}
				}
			}
			
			private void ScanFactoriesRecursive (XmlTextReader reader, string configKey)
			
			{
				int i1;
				string string1;
				string string2;
				string string3;
				string string4;
				string string5;
				string string6;
				string string7;
				string string8;
				i1 = reader.Depth;
				this.StrictReadToNextElement (reader);
				
			L_02A1:
				
				{
				}
				if (reader.Depth != (i1 + 1))
				{
					return;
				}
				if ((string8 = reader.Name) != null)
				{
					string8 = string.IsInterned (string8);
					switch (string8)
					{
						case "sectionGroup":
						
						{
								string1 = ((string) null);
								if (reader.HasAttributes)
								{
									while (reader.MoveToNextAttribute ())
									{
										if (reader.Name != "name")
										{
											this.ThrowUnrecognizedAttribute (reader);
										}
										string1 = reader.Value;
									}
									bool b1 = reader.MoveToElement ();
								}
								this.CheckRequiredAttribute (string1, "name", reader);
								this.VerifySectionName (string1, reader);
								string2 = ConfigurationRecord.TagKey (configKey, string1);
								if (HaveFactoryEnum.Section == this.HaveFactory (string1))
								{
									throw this.BuildConfigError ("Tag name already defined", reader);
								}
								this.EnsureFactories[string2] = ConfigurationRecord.GroupSingleton;
								this.ScanFactoriesRecursive (reader, string2);
								goto L_02A1;
						}
						case "section":
						
						{
								string3 = ((string) null);
								string4 = ((string) null);
								if (reader.HasAttributes)
								{
									while (reader.MoveToNextAttribute ())
									{
										if ((string8 = reader.Name) != null)
										{
											string8 = string.IsInterned (string8);
											switch (string8)
											{
												case "name":
												
												{
														string3 = reader.Value;
														continue;
												}
												case "type":
												
												{
														string4 = reader.Value;
														continue;
												}
												default:
												
												{
														if ((string8 == "allowLocation") || (string8 == "allowDefinition"))
														{
															continue;
														}
														break;
												}
											}
										}
										this.ThrowUnrecognizedAttribute (reader);
									}
									bool b2 = reader.MoveToElement ();
								}
								this.CheckRequiredAttribute (string3, "name", reader);
								this.CheckRequiredAttribute (string4, "type", reader);
								this.VerifySectionName (string3, reader);
								string5 = ConfigurationRecord.TagKey (configKey, string3);
								if (this.HaveFactory (string5) != HaveFactoryEnum.NotFound)
								{
									throw this.BuildConfigError ("Tag name already defined", reader);
								}
								this.EnsureFactories[string5] = string4;
								goto L_0288;
						}
						case "remove":
						
						{
								string6 = ((string) null);
								if (reader.HasAttributes)
								{
									while (reader.MoveToNextAttribute ())
									{
										if (reader.Name != "name")
										{
											this.ThrowUnrecognizedAttribute (reader);
										}
										string6 = reader.Value;
									}
									bool b3 = reader.MoveToElement ();
								}
								if (string6 == null)
								{
									this.ThrowRequiredAttribute (reader, "name");
								}
								this.VerifySectionName (string6, reader);
								string7 = ConfigurationRecord.TagKey (configKey, string6);
								if (this.HaveFactory (string7) != HaveFactoryEnum.Section)
								{
									throw this.BuildConfigError ("Could not remove section handler", reader);
								}
								this.EnsureFactories[string6] = ConfigurationRecord.RemovedFactorySingleton;
								goto L_0288;
						}
						case "clear":
						
						{
								this.CheckForUnrecognizedAttributes (reader);
								this.factories = ((Hashtable) null);
								this.factoriesNoInherit = true;
								goto L_0288;
						}
					}
				}
				this.ThrowUnrecognizedElement (reader);
				
			L_0288:
				
				{
				}
				this.StrictReadToNextElement (reader);
				if (reader.Depth > (i1 + 1))
				{
					this.ThrowUnrecognizedElement (reader);
				}
				goto L_02A1;
			}
			
			private void ScanSectionsRecursive (XmlTextReader reader, string configKey)
			
			{
				string string1;
				string string2;
				HaveFactoryEnum haveFactoryEnum1;
				int i1 = reader.Depth;
				if (configKey == null)
				{
					i1 = 0;
				}
				else
				{
					this.StrictReadToNextElement (reader);
				}
				while (reader.Depth == (i1 + 1))
				{
					string1 = reader.Name;
					string2 = ConfigurationRecord.TagKey (configKey, string1);
					haveFactoryEnum1 = this.HaveFactory (string2);
					if (haveFactoryEnum1 == HaveFactoryEnum.Group)
					{
						this.ScanSectionsRecursive (reader, string2);
					}
					else if (haveFactoryEnum1 == HaveFactoryEnum.NotFound)
					{
						switch (string2)
						{
							case "location":
							
							{
									switch (string2)
									{
										case "configSections":
										
										{
												throw this.BuildConfigError ("ClientConfig: too many ConfigSection elements", reader);
										}
										default:
										
										{
												throw this.BuildConfigError (("Unrecognized ConfigurationSection: " + string1), reader);
										}
									}
							}
							default:
							
							{
									break;
							}
						}
					}
					else
					{
						if (this.unevaluatedSections == null)
						{
							this.unevaluatedSections = new Hashtable ();
						}
						this.unevaluatedSections[string2] = null;
					}
					this.StrictSkipToNextElement (reader);
				}
			}
			
			private void StrictReadToNextElement (XmlTextReader reader)
			
			{
				while (reader.Read () && (reader.NodeType != XmlNodeType.Element))
				{
					this.CheckIgnorableNodeType (reader);
				}
			}
			
			private void StrictSkipToNextElement (XmlTextReader reader)
			
			{
				reader.Skip ();
				while ((! reader.EOF) && (reader.NodeType != XmlNodeType.Element))
				{
					this.CheckIgnorableNodeType (reader);
					bool b1 = reader.Read ();
				}
			}
			
			private static string TagKey (string configKey, string tagName)
			
			{
				if (configKey != null)
				{
					return (configKey + "/" + tagName);
				}
				else
				{
					return tagName;
				}
			}
			
			private void ThrowRequiredAttribute (XmlTextReader reader, string attrib)
			
			{
				throw this.BuildConfigError ("Missing required attribute", reader);
			}
			
			private void ThrowUnrecognizedAttribute (XmlTextReader reader)
			
			{
				throw this.BuildConfigError ("Configbaseunrecognizedattribute", reader);
			}
			
			private void ThrowUnrecognizedElement (XmlTextReader reader)
			
			{
				throw this.BuildConfigError ("ConfigBase unrecognized element", reader);
			}
			
			private ConfigurationException TranslateXmlParseOrEvaluateErrors (Exception e)
			
			{
				XmlException xmlException1 = (e as XmlException);
				if (xmlException1 == null)
				{
					return new ConfigurationException ("Error loading XML file", e, this.filename, 0);
				}
				else
				{
					return new ConfigurationException (xmlException1.Message, e, this.filename, xmlException1.LineNumber);
				}
			}
			
			private void VerifySectionName (string tagName, XmlTextReader reader)
			
			{
				if (tagName.StartsWith ("config"))
				{
					ConfigurationException configurationException1 = this.BuildConfigError ("Tag name cannot begin with config", reader);
				}
				if (tagName == "location")
				{
					ConfigurationException configurationException2 = this.BuildConfigError ("Tag name cannot be location", reader);
				}
			}
			
		#endregion
	}
	
}

