//
// Decompiled with: Decompiler.NET, Version=2.0.0.230, Culture=neutral, PublicKeyToken=null, Version: 2.0.0.230
// Decompilation Started at: 14/02/2008 11:30:26
// Copyright 2003 - 2004, Jungle Creatures, Inc., All Rights Reserved. http://www.junglecreatures.com/
// Written by Jonathan Pierce, Email: support@junglecreatures.com
//

namespace OpenNETCF.Configuration

{
		
		#region Namespace Import Declarations
		
			using System.Collections;
			using System.Collections.Specialized;
			using System.Globalization;
			using System.Reflection;
			using System.Threading;
			using System;
			
		#endregion
		
	public sealed class ConfigurationSettings
	
	{
		
		#region Fields
			private static string appBase;
			private static IConfigurationSystem configSystem;
			private static bool configurationInitialized;
			private static Exception initError;
		#endregion
		
		#region Constructors
		
			private ConfigurationSettings ()
			
			{
			}
			
			
			static ConfigurationSettings ()
			
			{
				ConfigurationSettings.configSystem = ((IConfigurationSystem) null);
				ConfigurationSettings.configurationInitialized = false;
				ConfigurationSettings.initError = ((Exception) null);
				ConfigurationSettings.appBase = ((string) null);
			}
			
		#endregion
		
		#region Properties
		
			public static NameValueCollection AppSettings
			
			{
				get
				{
					ConfigurationSettings.appBase = Assembly.GetCallingAssembly ().GetName ().CodeBase;
					ReadOnlyNameValueCollection readOnlyNameValueCollection1 = ((ReadOnlyNameValueCollection) ConfigurationSettings.GetConfig ("appSettings"));
					if (readOnlyNameValueCollection1 == null)
					{
						readOnlyNameValueCollection1 = new ReadOnlyNameValueCollection (((IHashCodeProvider) new CaseInsensitiveHashCodeProvider (CultureInfo.InvariantCulture)), ((IComparer) new CaseInsensitiveComparer (CultureInfo.InvariantCulture)));
						readOnlyNameValueCollection1.SetReadOnly ();
					}
					return readOnlyNameValueCollection1;
				}
			}
			
			
			internal static bool SetConfigurationSystemInProgress
			
			{
				get
				{
					if (ConfigurationSettings.configSystem == null)
					{
						return false;
					}
					else
					{
						return (! ConfigurationSettings.configurationInitialized);
					}
				}
			}
			
		#endregion
		
		#region Methods
		
			public static object GetConfig (string sectionName, string appPath)
			
			{
				Type type1;
				if (! ConfigurationSettings.configurationInitialized)
				{
					type1 = typeof (ConfigurationSettings);
					lock (type1)
					{
						if (ConfigurationSettings.appBase == null)
						{
							ConfigurationSettings.appBase = appPath;
						}
						if ((ConfigurationSettings.configSystem == null) && (! ConfigurationSettings.SetConfigurationSystemInProgress))
						{
							ConfigurationSettings.SetConfigurationSystem (((IConfigurationSystem) new DefaultConfigurationSystem (ConfigurationSettings.appBase)));
						}
						ConfigurationSettings.appBase = ((string) null);
					}
				}
				if (ConfigurationSettings.initError == null)
				{
					return ConfigurationSettings.configSystem.GetConfig (sectionName);
				}
				else
				{
					throw ConfigurationSettings.initError;
				}
			}
			
			public static object GetConfig (string sectionName)
			
			{
				Type type1;
				if (! ConfigurationSettings.configurationInitialized)
				{
					type1 = typeof (ConfigurationSettings);
					lock (type1)
					{
						if (ConfigurationSettings.appBase == null)
						{
							ConfigurationSettings.appBase = Assembly.GetCallingAssembly ().GetName ().CodeBase;
						}
						if ((ConfigurationSettings.configSystem == null) && (! ConfigurationSettings.SetConfigurationSystemInProgress))
						{
							ConfigurationSettings.SetConfigurationSystem (((IConfigurationSystem) new DefaultConfigurationSystem (ConfigurationSettings.appBase)));
						}
						ConfigurationSettings.appBase = ((string) null);
					}
				}
				if (ConfigurationSettings.initError == null)
				{
					return ConfigurationSettings.configSystem.GetConfig (sectionName);
				}
				else
				{
					throw ConfigurationSettings.initError;
				}
			}
			
			internal static void SetConfigurationSystem (IConfigurationSystem ConfigSystem)
			
			{
				Exception exception1;
				Type type1 = typeof (ConfigurationSettings);
				lock (type1)
				{
					if (ConfigurationSettings.configSystem != null)
					{
						throw new InvalidOperationException ("Config system already set");
					}
					else
					{
						try
						{
							ConfigurationSettings.configSystem = ConfigSystem;
							ConfigurationSettings.configSystem.Init ();
						}
						catch (Exception exception2)
						{
							exception1 = exception2;
							ConfigurationSettings.initError = exception1;
							throw;
						}
						ConfigurationSettings.configurationInitialized = true;
					}
				}
			}
			
		#endregion
	}
	
}

