//
// Decompiled with: Decompiler.NET, Version=2.0.0.230, Culture=neutral, PublicKeyToken=null, Version: 2.0.0.230
// Decompilation Started at: 14/02/2008 11:30:26
// Copyright 2003 - 2004, Jungle Creatures, Inc., All Rights Reserved. http://www.junglecreatures.com/
// Written by Jonathan Pierce, Email: support@junglecreatures.com
//

namespace OpenNETCF.Diagnostics

{
		
		#region Namespace Import Declarations
		
			using System;
			using System.Text;
			
		#endregion
		
	public class ProcessEntryInfo
	
	{
		
		#region Fields
			private const int AccessKeyOffset = 560;
			public uint cntThreads;
			public uint cntUsage;
			private const int DefaultHeapIDOffset = 12;
			public uint dwFlags;
			private const int dwFlagsOffset = 32;
			public uint dwSize;
			private const int ExeFileOffset = 36;
			private const int MAX_PATH = 260;
			private const int MemoryBaseOffset = 556;
			private const int ModuleIDOffset = 16;
			private const int ParentProcessIDOffset = 24;
			public int pcPriClassBase;
			private const int PriClassBaseOffset = 28;
			private const int ProcessIDOffset = 8;
			private const int Size = 564;
			private const int SizeOffset = 0;
			public string szExeFile;
			public uint th32AccessKey;
			public uint th32DefaultHeapID;
			public uint th32MemoryBase;
			public uint th32ModuleID;
			public uint th32ParentProcessID;
			public uint th32ProcessID;
			private const int ThreadsOffset = 20;
			private const int UsageOffset = 4;
		#endregion
		
		#region Constructors
		
			public ProcessEntryInfo ()
			
			{
			}
			
			
			public ProcessEntryInfo (byte[] aData)
			
			{
				this.dwSize = ProcessEntryInfo.GetUInt (aData, 0);
				this.cntUsage = ProcessEntryInfo.GetUInt (aData, 4);
				this.th32ProcessID = ProcessEntryInfo.GetUInt (aData, 8);
				this.th32DefaultHeapID = ProcessEntryInfo.GetUInt (aData, 12);
				this.th32ModuleID = ProcessEntryInfo.GetUInt (aData, 16);
				this.cntThreads = ProcessEntryInfo.GetUInt (aData, 20);
				this.th32ParentProcessID = ProcessEntryInfo.GetUInt (aData, 24);
				this.pcPriClassBase = ((int) ProcessEntryInfo.GetUInt (aData, 28));
				this.dwFlags = ProcessEntryInfo.GetUInt (aData, 32);
				this.szExeFile = ProcessEntryInfo.GetString (aData, 36, 260);
				this.th32MemoryBase = ProcessEntryInfo.GetUInt (aData, 556);
				this.th32AccessKey = ProcessEntryInfo.GetUInt (aData, 560);
			}
			
		#endregion
		
		#region Properties
		
			public ulong BaseAddress
			
			{
				get
				{
					return ((ulong) this.th32MemoryBase);
				}
			}
			
			
			public string Name
			
			{
				get
				{
					return this.szExeFile.Substring (0, this.szExeFile.IndexOf ('\0'));
				}
			}
			
			
			public ulong PID
			
			{
				get
				{
					return ((ulong) this.th32ProcessID);
				}
			}
			
			
			public ulong ThreadCount
			
			{
				get
				{
					return ((ulong) this.cntThreads);
				}
			}
			
		#endregion
		
		#region Methods
		
			public byte[] AllocateBytes ()
			
			{
				byte[] byteArray1 = new byte[564];
				ProcessEntryInfo.SetUInt (byteArray1, 0, 564);
				return byteArray1;
			}
			
			private static string GetString (byte[] aData, int Offset, int Length)
			
			{
				return Encoding.Unicode.GetString (aData, Offset, Length);
			}
			
			private static uint GetUInt (byte[] aData, int Offset)
			
			{
				return BitConverter.ToUInt32 (aData, Offset);
			}
			
			private static UInt16 GetUShort (byte[] aData, int Offset)
			
			{
				return BitConverter.ToUInt16 (aData, Offset);
			}
			
			private static void SetString (byte[] aData, int Offset, string Value)
			
			{
				byte[] byteArray1 = Encoding.ASCII.GetBytes (Value);
				Buffer.BlockCopy (((Array) byteArray1), 0, ((Array) aData), Offset, byteArray1.Length);
			}
			
			private static void SetUInt (byte[] aData, int Offset, int Value)
			
			{
				byte[] byteArray1 = BitConverter.GetBytes (Value);
				Buffer.BlockCopy (((Array) byteArray1), 0, ((Array) aData), Offset, byteArray1.Length);
			}
			
			private static void SetUShort (byte[] aData, int Offset, int Value)
			
			{
				byte[] byteArray1 = BitConverter.GetBytes (((short) Value));
				Buffer.BlockCopy (((Array) byteArray1), 0, ((Array) aData), Offset, byteArray1.Length);
			}
			
		#endregion
	}
	
}

