//
// Decompiled with: Decompiler.NET, Version=2.0.0.230, Culture=neutral, PublicKeyToken=null, Version: 2.0.0.230
// Decompilation Started at: 14/02/2008 11:22:16
// Copyright 2003 - 2004, Jungle Creatures, Inc., All Rights Reserved. http://www.junglecreatures.com/
// Written by Jonathan Pierce, Email: support@junglecreatures.com
//

namespace LanmarkControls.LECHardwareAbstraction.FPGAInterface

{
		
		#region Namespace Import Declarations
		
			using LanmarkControls.CommonInteropLib.PInvoke;
			using LanmarkControls.CommonLib.General;
			using LanmarkControls.CommonLib.Threading;
			using LanmarkControls.LECHardwareAbstraction;
			using System;
			using System.Threading;
			
		#endregion
		
	public class JobExceptMsgThread : BaseQueueThread
	
	{
		
		#region Fields
			private string m_strEventName;
		#endregion
		
		#region Constructors
		
			public JobExceptMsgThread (AutoResetEvent poContentAvailableSignal)
				 : base (poContentAvailableSignal)
			
			{
				this.m_strEventName = "";
			}
			
		#endregion
		
		#region Properties
		
			protected string EventName
			
			{
				get
				{
					if (this.m_strEventName.Length == 0)
					{
						this.m_strEventName = LECHAL.Instance.fpgaInterface.EventName (LanmarkControls.LECHardwareAbstraction.LECHAL.MecFPGAEvent.MecFPGAEvent_EXCPTMSG);
					}
					return this.m_strEventName;
				}
			}
			
		#endregion
		
		#region Methods
		
			protected override bool ExecuteWorkThread ()
			
			{
				MecExceptionMessage mecExceptionMessage1;
				int i1;
				NamedEvent namedEvent1;
				Logging.Instance.Log (4, "JobExceptMsgThread.ExecuteWorkThread() called.");
				bool b1 = false;
				while (! base.Shutdown)
				{
					i1 = 0;
					while ((! base.Shutdown) && (((mecExceptionMessage1 = LECHAL.Instance.fpgaInterface.NextExceptionEvent ()) != null) || b1))
					{
						if (mecExceptionMessage1 == null)
						{
							Logging.Instance.Log (4, ("JobExceptMsgThread.ExecuteWorkThread() - " + LECHAL.Instance.fpgaInterface.MessageLog));
							if (i1++ == 1)
							{
								Logging.Instance.Log (4, "JobExceptMsgThread.ExecuteWorkThread() - Signaled by FPGA, but no exception mess"
								+ "age detected.  Exceeded retry. Break.");
								break;
							}
							Logging.Instance.Log (4, "JobExceptMsgThread.ExecuteWorkThread() - Signaled by FPGA, but no exception mess"
							+ "age detected.  Retry.");
							continue;
						}
						b1 = false;
						Logging.Instance.Log (4, "JobExceptMsgThread.ExecuteWorkThread() - Message found. Queue.");
						base.QueueContent (mecExceptionMessage1);
					}
					if (! base.Shutdown)
					{
						if (this.EventName.Length == 0)
						{
							return false;
						}
						namedEvent1 = new NamedEvent (this.EventName, true);
						Logging.Instance.Log (4, "JobExceptMsgThread.ExecuteWorkThread() - No messages found. Waiting.");
						bool b2 = namedEvent1.Wait (1);
						namedEvent1.Reset ();
						b1 = true;
					}
				}
				return false;
			}
			
			protected override bool InitializeWorkThread ()
			
			{
				Logging.Instance.Log (4, "JobExceptMsgThread.InitializeWorkThread() called.");
				return base.InitializeWorkThread ();
			}
			
			protected override void InterruptWorkThread (bool pbAbort)
			
			{
				NamedEvent namedEvent1;
				Logging.Instance.Log (4, "JobExceptMsgThread.InterruptWorkThread() called.");
				if (this.EventName.Length != 0)
				{
					namedEvent1 = new NamedEvent (this.EventName, false);
					bool b1 = namedEvent1.Pulse ();
				}
				base.InterruptWorkThread (pbAbort);
			}
			
			protected override bool TerminateWorkThread ()
			
			{
				Logging.Instance.Log (4, "JobExceptMsgThread.TerminateWorkThread() called.");
				return base.TerminateWorkThread ();
			}
			
		#endregion
	}
	
}

