//
// Decompiled with: Decompiler.NET, Version=2.0.0.230, Culture=neutral, PublicKeyToken=null, Version: 2.0.0.230
// Decompilation Started at: 14/02/2008 11:22:16
// Copyright 2003 - 2004, Jungle Creatures, Inc., All Rights Reserved. http://www.junglecreatures.com/
// Written by Jonathan Pierce, Email: support@junglecreatures.com
//

namespace LanmarkControls.LECHardwareAbstraction.SerialPortInterface

{
		
		#region Namespace Import Declarations
		
			using System;
			using System.Runtime.InteropServices;
			using System.Text;
			using System.Threading;
			
		#endregion
		
	public class Port : IDisposable
	
	{
		
		#region Fields
			private int brk;
			private IntPtr closeEvent;
			private string closeEventName;
			public event CommChangeEvent CTSChange;
			public event CommEvent DataReceived;
			private DCB dcb;
			public event CommChangeEvent DSRChange;
			private int dtr;
			private bool dtravail;
			private Thread eventThread;
			public event CommEvent FlagCharReceived;
			public event CommEvent HighWater;
			private IntPtr hPort;
			private uint inputLength;
			private bool isOpen;
			public event CommErrorEvent OnError;
			private string portName;
			private DetailedPortSettings portSettings;
			public event CommEvent PowerEvent;
			private uint ptxBuffer;
			public event CommChangeEvent RingChange;
			private byte rlinebyte;
			public event CommChangeEvent RLSDChange;
			private uint rthreshold;
			private int rts;
			private bool rtsavail;
			private byte[] rxBuffer;
			private Mutex rxBufferBusy;
			private uint rxBufferPointer;
			private uint rxBufferSize;
			public event CommEvent RxOverrun;
			private uint sthreshold;
			private ManualResetEvent threadStarted;
			private byte[] txBuffer;
			private uint txBufferSize;
			public event CommEvent TxDone;
		#endregion
		
		#region Nested Types
		
			public delegate void CommChangeEvent (bool NewState);
			
			public delegate void CommErrorEvent (string Description);
			
			public delegate void CommEvent ();
		#endregion
		
		#region Constructors
		
			public Port (string PortName)
			
			{
				this.hPort = ((IntPtr) (-1));
				this.rxBufferSize = 1024;
				this.rxBufferPointer = uint.MinValue;
				this.rthreshold = 1;
				this.rlinebyte = 13;
				this.txBufferSize = 1024;
				this.ptxBuffer = uint.MinValue;
				this.sthreshold = 1;
				this.rxBufferBusy = new Mutex ();
				this.dcb = new DCB ();
				this.threadStarted = new ManualResetEvent (false);
				this.closeEventName = "CloseEvent";
				this.rts = -1;
				this.rtsavail = false;
				this.dtr = -1;
				this.dtravail = false;
				this.brk = -1;
				this.isOpen = false;
				this.portName = PortName;
				this.Init ();
			}
			
			
			public Port (string PortName, BasicPortSettings InitialSettings)
			
			{
				this.hPort = ((IntPtr) (-1));
				this.rxBufferSize = 1024;
				this.rxBufferPointer = uint.MinValue;
				this.rthreshold = 1;
				this.rlinebyte = 13;
				this.txBufferSize = 1024;
				this.ptxBuffer = uint.MinValue;
				this.sthreshold = 1;
				this.rxBufferBusy = new Mutex ();
				this.dcb = new DCB ();
				this.threadStarted = new ManualResetEvent (false);
				this.closeEventName = "CloseEvent";
				this.rts = -1;
				this.rtsavail = false;
				this.dtr = -1;
				this.dtravail = false;
				this.brk = -1;
				this.isOpen = false;
				this.portName = PortName;
				this.Init ();
				this.portSettings.BasicSettings = InitialSettings;
			}
			
			
			public Port (string PortName, DetailedPortSettings InitialSettings)
			
			{
				this.hPort = ((IntPtr) (-1));
				this.rxBufferSize = 1024;
				this.rxBufferPointer = uint.MinValue;
				this.rthreshold = 1;
				this.rlinebyte = 13;
				this.txBufferSize = 1024;
				this.ptxBuffer = uint.MinValue;
				this.sthreshold = 1;
				this.rxBufferBusy = new Mutex ();
				this.dcb = new DCB ();
				this.threadStarted = new ManualResetEvent (false);
				this.closeEventName = "CloseEvent";
				this.rts = -1;
				this.rtsavail = false;
				this.dtr = -1;
				this.dtravail = false;
				this.brk = -1;
				this.isOpen = false;
				this.portName = PortName;
				this.Init ();
				this.portSettings = InitialSettings;
			}
			
			
			public Port (string PortName, uint RxBufferSize, uint TxBufferSize)
			
			{
				this.hPort = ((IntPtr) (-1));
				this.rxBufferSize = 1024;
				this.rxBufferPointer = uint.MinValue;
				this.rthreshold = 1;
				this.rlinebyte = 13;
				this.txBufferSize = 1024;
				this.ptxBuffer = uint.MinValue;
				this.sthreshold = 1;
				this.rxBufferBusy = new Mutex ();
				this.dcb = new DCB ();
				this.threadStarted = new ManualResetEvent (false);
				this.closeEventName = "CloseEvent";
				this.rts = -1;
				this.rtsavail = false;
				this.dtr = -1;
				this.dtravail = false;
				this.brk = -1;
				this.isOpen = false;
				this.rxBufferSize = RxBufferSize;
				this.txBufferSize = TxBufferSize;
				this.Init ();
			}
			
			
			public Port (string PortName, BasicPortSettings InitialSettings, uint RxBufferSize, uint TxBufferSize)
			
			{
				this.hPort = ((IntPtr) (-1));
				this.rxBufferSize = 1024;
				this.rxBufferPointer = uint.MinValue;
				this.rthreshold = 1;
				this.rlinebyte = 13;
				this.txBufferSize = 1024;
				this.ptxBuffer = uint.MinValue;
				this.sthreshold = 1;
				this.rxBufferBusy = new Mutex ();
				this.dcb = new DCB ();
				this.threadStarted = new ManualResetEvent (false);
				this.closeEventName = "CloseEvent";
				this.rts = -1;
				this.rtsavail = false;
				this.dtr = -1;
				this.dtravail = false;
				this.brk = -1;
				this.isOpen = false;
				this.rxBufferSize = RxBufferSize;
				this.txBufferSize = TxBufferSize;
				this.Init ();
				this.portSettings.BasicSettings = InitialSettings;
			}
			
			
			public Port (string PortName, DetailedPortSettings InitialSettings, uint RxBufferSize, uint TxBufferSize)
			
			{
				this.hPort = ((IntPtr) (-1));
				this.rxBufferSize = 1024;
				this.rxBufferPointer = uint.MinValue;
				this.rthreshold = 1;
				this.rlinebyte = 13;
				this.txBufferSize = 1024;
				this.ptxBuffer = uint.MinValue;
				this.sthreshold = 1;
				this.rxBufferBusy = new Mutex ();
				this.dcb = new DCB ();
				this.threadStarted = new ManualResetEvent (false);
				this.closeEventName = "CloseEvent";
				this.rts = -1;
				this.rtsavail = false;
				this.dtr = -1;
				this.dtravail = false;
				this.brk = -1;
				this.isOpen = false;
				this.rxBufferSize = RxBufferSize;
				this.txBufferSize = TxBufferSize;
				this.Init ();
				this.portSettings = InitialSettings;
			}
			
		#endregion
		
		#region Properties
		
			public bool Break
			
			{
				get
				{
					if (this.isOpen)
					{
						return (this.brk == 1);
					}
					else
					{
						return false;
					}
				}
				set
				{
					if (((! this.isOpen) || (this.brk < 0)) || (this.hPort == ((IntPtr) (-1))))
					{
					}
					else
					{
						if (value)
						{
							if (CommAPI.EscapeCommFunction (this.hPort, CommEscapes.SETBREAK))
							{
								this.brk = 1;
								return;
							}
							else
							{
								throw new CommPortException ("Failed to set break!");
							}
						}
						if (CommAPI.EscapeCommFunction (this.hPort, CommEscapes.CLRBREAK))
						{
							this.brk = 0;
						}
						else
						{
							throw new CommPortException ("Failed to clear break!");
						}
					}
				}
			}
			
			
			public DetailedPortSettings DetailedSettings
			
			{
				get
				{
					return this.portSettings;
				}
				set
				{
					this.portSettings = value;
				}
			}
			
			
			public bool DTRAvailable
			
			{
				get
				{
					return this.dtravail;
				}
			}
			
			
			public bool DTREnable
			
			{
				get
				{
					return (this.dtr == 1);
				}
				set
				{
					if ((this.dtr < 0) || (this.hPort == ((IntPtr) (-1))))
					{
					}
					else
					{
						if (value)
						{
							if (CommAPI.EscapeCommFunction (this.hPort, CommEscapes.SETDTR))
							{
								this.dtr = 1;
								return;
							}
							else
							{
								throw new CommPortException ("Failed to set DTR!");
							}
						}
						if (CommAPI.EscapeCommFunction (this.hPort, CommEscapes.CLRDTR))
						{
							this.dtr = 0;
						}
						else
						{
							throw new CommPortException ("Failed to clear DTR!");
						}
					}
				}
			}
			
			
			public uint InBufferCount
			
			{
				get
				{
					if (this.isOpen)
					{
						return this.rxBufferPointer;
					}
					else
					{
						return uint.MinValue;
					}
				}
			}
			
			
			public byte[] Input
			
			{
				get
				{
					byte[] byteArray1;
					if (! this.isOpen)
					{
						return null;
					}
					(byteArray1 = new byte[this.inputLength]).Initialize ();
					if (this.rxBufferPointer <= uint.MinValue)
					{
						return byteArray1;
					}
					uint uInt32_1 = ((this.rxBufferPointer < this.inputLength) ? this.rxBufferPointer : this.inputLength);
					bool b1 = this.rxBufferBusy.WaitOne ();
					Array.Copy (((Array) this.rxBuffer), 0, ((Array) byteArray1), 0, ((int) uInt32_1));
					Array.Copy (((Array) this.rxBuffer), ((int) uInt32_1), ((Array) this.rxBuffer), 0, ((int) (((long) this.rxBuffer.GetUpperBound (0)) - ((long) uInt32_1))));
					this.rxBufferPointer -= uInt32_1;
					this.rxBufferBusy.ReleaseMutex ();
					return byteArray1;
				}
			}
			
			
			public uint InputLen
			
			{
				get
				{
					return this.inputLength;
				}
				set
				{
					this.inputLength = value;
				}
			}
			
			
			public bool IsOpen
			
			{
				get
				{
					return this.isOpen;
				}
			}
			
			
			public uint OutBufferCount
			
			{
				get
				{
					if (this.isOpen)
					{
						return this.ptxBuffer;
					}
					else
					{
						return uint.MinValue;
					}
				}
			}
			
			
			public byte[] Output
			
			{
				set
				{
					if (! this.isOpen)
					{
						return;
					}
					int i1 = 0;
					if (((long) value.GetLength (0)) <= ((long) this.sthreshold))
					{
						value.CopyTo (((Array) this.txBuffer), ((int) this.ptxBuffer));
						this.ptxBuffer = ((uint) (((int) this.ptxBuffer) + value.Length));
						if (this.ptxBuffer >= this.sthreshold)
						{
							bool b3 = CommAPI.WriteFile (this.hPort, this.txBuffer, this.ptxBuffer, ref i1);
							this.ptxBuffer = uint.MinValue;
						}
					}
					else
					{
						if (this.ptxBuffer > uint.MinValue)
						{
							bool b1 = CommAPI.WriteFile (this.hPort, this.txBuffer, this.ptxBuffer, ref i1);
							this.ptxBuffer = uint.MinValue;
						}
						bool b2 = CommAPI.WriteFile (this.hPort, value, ((uint) value.GetLength (0)), ref i1);
					}
				}
			}
			
			
			public string PortName
			
			{
				get
				{
					return this.portName;
				}
				set
				{
					this.portName = value;
				}
			}
			
			
			public byte RLineByte
			
			{
				get
				{
					return this.rlinebyte;
				}
				set
				{
					this.rlinebyte = value;
				}
			}
			
			
			public uint RThreshold
			
			{
				get
				{
					return this.rthreshold;
				}
				set
				{
					this.rthreshold = value;
				}
			}
			
			
			public bool RTSAvailable
			
			{
				get
				{
					return this.rtsavail;
				}
			}
			
			
			public bool RTSEnable
			
			{
				get
				{
					return (this.rts == 1);
				}
				set
				{
					if ((this.rts < 0) || (this.hPort == ((IntPtr) (-1))))
					{
					}
					else
					{
						if (value)
						{
							if (CommAPI.EscapeCommFunction (this.hPort, CommEscapes.SETRTS))
							{
								this.rts = 1;
								return;
							}
							else
							{
								throw new CommPortException ("Failed to set RTS!");
							}
						}
						if (CommAPI.EscapeCommFunction (this.hPort, CommEscapes.CLRRTS))
						{
							this.rts = 0;
						}
						else
						{
							throw new CommPortException ("Failed to clear RTS!");
						}
					}
				}
			}
			
			
			public BasicPortSettings Settings
			
			{
				get
				{
					return this.portSettings.BasicSettings;
				}
				set
				{
					this.portSettings.BasicSettings = value;
				}
			}
			
			
			public uint SThreshold
			
			{
				get
				{
					return this.sthreshold;
				}
				set
				{
					this.sthreshold = value;
				}
			}
			
		#endregion
		
		#region Methods
		
			public bool Close ()
			
			{
				if (! this.isOpen)
				{
					return false;
				}
				else if (! CommAPI.CloseHandle (this.hPort))
				{
					return false;
				}
				else
				{
					bool b1 = CommAPI.SetEvent (this.closeEvent);
					this.isOpen = false;
					this.hPort = ((IntPtr) (-1));
					bool b2 = CommAPI.SetEvent (this.closeEvent);
					return true;
				}
			}
			
			private void CommEventThread ()
			
			{
				CommEventFlags commEventFlags1;
				byte[] byteArray1;
				int i1;
				int i2;
				int i3;
				string string1;
				CommErrorFlags commErrorFlags1;
				CommStat commStat1;
				string string2;
				StringBuilder stringBuilder1;
				uint uInt32_1;
				int i4;
				Exception exception1;
				try
				{
					commEventFlags1 = CommEventFlags.NONE;
					byteArray1 = new byte[10];
					i1 = 0;
					bool b1 = CommAPI.SetCommMask (this.hPort, CommEventFlags.ALL);
					bool b2 = this.threadStarted.Set ();
					goto L_03E3;
					
				L_008D:
					
					{
					}
					string1 = string.Format ("Wait Failed: {0}", i2);
					throw new CommPortException (string1);
					
				L_01DD:
					
					{
					}
					uInt32_1 = uint.MinValue;
					bool b5 = CommAPI.GetCommModemStatus (this.hPort, ref uInt32_1);
					if (((commEventFlags1 & CommEventFlags.CTS) != CommEventFlags.NONE) && (this.CTSChange != null))
					{
						this.CTSChange (((uInt32_1 & 16) != uint.MinValue));
					}
					if (((commEventFlags1 & CommEventFlags.DSR) != CommEventFlags.NONE) && (this.DSRChange != null))
					{
						this.DSRChange (((uInt32_1 & 32) != uint.MinValue));
					}
					if (((commEventFlags1 & CommEventFlags.RING) != CommEventFlags.NONE) && (this.RingChange != null))
					{
						this.RingChange (((uInt32_1 & 64) != uint.MinValue));
					}
					if (((commEventFlags1 & CommEventFlags.RLSD) != CommEventFlags.NONE) && (this.RLSDChange != null))
					{
						this.RLSDChange (((((int) uInt32_1) & 128) != 0));
					}
					if (((commEventFlags1 & CommEventFlags.TXEMPTY) != CommEventFlags.NONE) && (this.TxDone != null))
					{
						this.TxDone ();
					}
					if (((commEventFlags1 & CommEventFlags.RXFLAG) != CommEventFlags.NONE) && (this.FlagCharReceived != null))
					{
						this.FlagCharReceived ();
					}
					if (((commEventFlags1 & CommEventFlags.POWER) != CommEventFlags.NONE) && (this.PowerEvent != null))
					{
						this.PowerEvent ();
					}
					if (((commEventFlags1 & CommEventFlags.RX80FULL) != CommEventFlags.NONE) && (this.HighWater != null))
					{
						this.HighWater ();
					}
					if (((commEventFlags1 & CommEventFlags.RXCHAR) != CommEventFlags.NONE) && (this.DataReceived != null))
					{
						bool b6 = CommAPI.ReadFile (this.hPort, byteArray1, 10, ref i1);
						i4 = i1;
						while (i1 > 0)
						{
							if (((long) this.rxBufferPointer) <= ((long) this.rxBuffer.GetUpperBound (0)))
							{
								bool b7 = this.rxBufferBusy.WaitOne ();
								this.rxBuffer[((int) this.rxBufferPointer)] = byteArray1[(i4 - i1)];
								this.rxBufferPointer = ((uint) (((int) this.rxBufferPointer) + 1));
								this.rxBufferBusy.ReleaseMutex ();
								if ((this.rthreshold != uint.MinValue) || (this.rlinebyte == byte.MinValue))
								{
									if (((this.rxBufferPointer % this.rthreshold) == uint.MinValue) && (this.DataReceived != null))
									{
										this.DataReceived ();
									}
								}
								else if ((this.rlinebyte == byteArray1[(i4 - i1)]) && (this.DataReceived != null))
								{
									this.DataReceived ();
								}
							}
							else if (this.RxOverrun != null)
							{
								this.RxOverrun ();
							}
							i1--;
						}
					}
					
				L_03E3:
					
					{
					}
					while (this.hPort != ((IntPtr) (-1)))
					{
						if (CommAPI.WaitCommEvent (this.hPort, ref commEventFlags1))
						{
							bool b4 = CommAPI.SetCommMask (this.hPort, CommEventFlags.ALL);
							if ((commEventFlags1 & CommEventFlags.ERR) == CommEventFlags.NONE)
							{
								goto L_01DD;
							}
							commErrorFlags1 =  ((CommErrorFlags) 0);
							commStat1 = new CommStat ();
							if (CommAPI.ClearCommError (this.hPort, ref commErrorFlags1, commStat1))
							{
								if ((commErrorFlags1 & CommErrorFlags.BREAK) ==  ((CommErrorFlags) 0))
								{
									stringBuilder1 = new StringBuilder ("UART Error: ", 80);
									if ((commErrorFlags1 & CommErrorFlags.FRAME) !=  ((CommErrorFlags) 0))
									{
										stringBuilder1 = stringBuilder1.Append ("Framing,");
									}
									if ((commErrorFlags1 & CommErrorFlags.IOE) !=  ((CommErrorFlags) 0))
									{
										stringBuilder1 = stringBuilder1.Append ("IO,");
									}
									if ((commErrorFlags1 & CommErrorFlags.OVERRUN) !=  ((CommErrorFlags) 0))
									{
										stringBuilder1 = stringBuilder1.Append ("Overrun,");
									}
									if ((commErrorFlags1 & CommErrorFlags.RXOVER) !=  ((CommErrorFlags) 0))
									{
										stringBuilder1 = stringBuilder1.Append ("Receive Overflow,");
									}
									if ((commErrorFlags1 & CommErrorFlags.RXPARITY) !=  ((CommErrorFlags) 0))
									{
										stringBuilder1 = stringBuilder1.Append ("Parity,");
									}
									if ((commErrorFlags1 & CommErrorFlags.TXFULL) !=  ((CommErrorFlags) 0))
									{
										stringBuilder1 = stringBuilder1.Append ("Transmit Overflow,");
									}
									if (stringBuilder1.Length == 12)
									{
										stringBuilder1 = stringBuilder1.Append ("Unknown");
									}
									if (this.OnError != null)
									{
										this.OnError (stringBuilder1.ToString ());
									}
									continue;
								}
								commEventFlags1 |= CommEventFlags.BREAK;
								goto L_01DD;
							}
							string2 = string.Format ("ClearCommError Failed: {0}", Marshal.GetLastWin32Error ());
							throw new CommPortException (string2);
						}
						i2 = Marshal.GetLastWin32Error ();
						if (i2 == 997)
						{
							Thread.Sleep (0);
						}
						else
						{
							if (i2 != 6)
							{
								goto L_008D;
							}
							i3 = CommAPI.WaitForSingleObject (this.closeEvent, 1000);
							if (i3 != 0)
							{
								goto L_008D;
							}
							this.hPort = ((IntPtr) (-1));
							bool b3 = this.threadStarted.Reset ();
							return;
						}
					}
				}
				catch (Exception exception2)
				{
					exception1 = exception2;
					throw exception1;
				}
			}
			
			public virtual void Dispose ()
			
			{
				if (this.isOpen)
				{
					bool b1 = this.Close ();
				}
			}
			
			~Port ()
			
			{
				if (this.isOpen)
				{
					bool b1 = this.Close ();
				}
			}
			
			private void Init ()
			
			{
				this.closeEvent = CommAPI.CreateEvent (true, false, this.closeEventName);
				this.rxBuffer = new byte[this.rxBufferSize];
				this.txBuffer = new byte[this.txBufferSize];
				this.portSettings = new DetailedPortSettings ();
			}
			
			public bool Open ()
			
			{
				int i1;
				string string1;
				UInt16 uInt16_1;
				if (this.isOpen)
				{
					return false;
				}
				this.hPort = CommAPI.CreateFile (this.portName);
				if (this.hPort == ((IntPtr) (-1)))
				{
					i1 = Marshal.GetLastWin32Error ();
					if (i1 == 5)
					{
						return false;
					}
					else
					{
						string1 = string.Format ("CreateFile Failed: {0}", i1);
						throw new CommPortException (string1);
					}
				}
				this.isOpen = true;
				bool b1 = CommAPI.SetupComm (this.hPort, this.rxBufferSize, this.txBufferSize);
				this.dcb.BaudRate = ((uint) this.portSettings.BasicSettings.BaudRate);
				this.dcb.ByteSize = this.portSettings.BasicSettings.ByteSize;
				this.dcb.EofChar = ((sbyte) this.portSettings.EOFChar);
				this.dcb.ErrorChar = ((sbyte) this.portSettings.ErrorChar);
				this.dcb.EvtChar = ((sbyte) this.portSettings.EVTChar);
				this.dcb.fAbortOnError = this.portSettings.AbortOnError;
				this.dcb.fBinary = true;
				this.dcb.fDsrSensitivity = this.portSettings.DSRSensitive;
				this.dcb.fDtrControl = ((DCB.DtrControlFlags) ((byte) this.portSettings.DTRControl));
				this.dcb.fErrorChar = this.portSettings.ReplaceErrorChar;
				this.dcb.fInX = this.portSettings.InX;
				this.dcb.fNull = this.portSettings.DiscardNulls;
				this.dcb.fOutX = this.portSettings.OutX;
				this.dcb.fOutxCtsFlow = this.portSettings.OutCTS;
				this.dcb.fOutxDsrFlow = this.portSettings.OutDSR;
				this.dcb.fParity = (this.portSettings.BasicSettings.Parity != Parity.none);
				this.dcb.fRtsControl = ((DCB.RtsControlFlags) ((byte) this.portSettings.RTSControl));
				this.dcb.fTXContinueOnXoff = this.portSettings.TxContinueOnXOff;
				this.dcb.Parity = ((byte) this.portSettings.BasicSettings.Parity);
				this.dcb.StopBits = ((byte) this.portSettings.BasicSettings.StopBits);
				this.dcb.XoffChar = ((sbyte) this.portSettings.XoffChar);
				this.dcb.XonChar = ((sbyte) this.portSettings.XonChar);
				this.dcb.XoffLim = (uInt16_1 = ((UInt16) (this.rxBufferSize / 10)));
				this.dcb.XonLim = uInt16_1;
				bool b2 = CommAPI.SetCommState (this.hPort, this.dcb);
				this.brk = 0;
				this.dtr = ((this.dcb.fDtrControl == DCB.DtrControlFlags.Enable) ? 1 : 0);
				this.rts = ((this.dcb.fRtsControl == DCB.RtsControlFlags.Enable) ? 1 : 0);
				CommTimeouts commTimeouts1 = new CommTimeouts ();
				commTimeouts1.ReadIntervalTimeout = (uint.MaxValue);
				commTimeouts1.ReadTotalTimeoutConstant = uint.MinValue;
				commTimeouts1.ReadTotalTimeoutMultiplier = uint.MinValue;
				commTimeouts1.WriteTotalTimeoutConstant = 5;
				commTimeouts1.WriteTotalTimeoutMultiplier = uint.MinValue;
				bool b3 = CommAPI.SetCommTimeouts (this.hPort, commTimeouts1);
				this.eventThread = new Thread (new ThreadStart (this.CommEventThread));
				this.eventThread.Priority = ThreadPriority.AboveNormal;
				this.eventThread.Start ();
				bool b4 = this.threadStarted.WaitOne ();
				return true;
			}
			
		#endregion
	}
	
}

