//
// Decompiled with: Decompiler.NET, Version=2.0.0.230, Culture=neutral, PublicKeyToken=null, Version: 2.0.0.230
// Decompilation Started at: 14/02/2008 11:22:16
// Copyright 2003 - 2004, Jungle Creatures, Inc., All Rights Reserved. http://www.junglecreatures.com/
// Written by Jonathan Pierce, Email: support@junglecreatures.com
//

namespace LanmarkControls.LECHardwareAbstraction.Utilities

{
		
		#region Namespace Import Declarations
		
			using LanmarkControls.CommonLib.Extension;
			using LanmarkControls.CommonLib.General;
			using LanmarkControls.CommonLib.Protocol;
			using LanmarkControls.LECHardwareAbstraction.FPGAInterface;
			using LanmarkControls.LECHardwareAbstraction;
			using LanmarkControls.LECHardwareAbstraction.PInvoke;
			using OpenNETCF.Diagnostics;
			using OpenNETCF.Net;
			using System.IO;
			using System.Net;
			using System;
			using System.Reflection;
			using System.Runtime.InteropServices;
			using System.Text;
			// Warning -- Type: LanmarkControls.CommonLib.General.Logging conflicts with a another imported type or namespace name,  Disabled Using Ref --> using Logging = LanmarkControls.CommonLib.General.Logging;
			
		#endregion
		
	public class SystemInfo
	
	{
		
		#region Fields
			private string currentJob;
			private uint lastError;
			public int LEC_SERIAL_NUMBER_LENGTH;
			private AdapterCollection m_oDeviceAdapters;
			private string m_strApplicationVersion;
			private string m_strDeviceName;
			private string m_strFPGAFirmwareVersion;
			private string m_strHeadSerialNumber;
			private string objectExtensionVersion;
			private IPAddress remoteIP;
			private uint stateCode;
		#endregion
		
		#region Constructors
		
			public SystemInfo ()
			
			{
				this.stateCode = uint.MinValue;
				this.remoteIP = IPAddress.Parse ("0.0.0.0");
				this.lastError = uint.MinValue;
				this.LEC_SERIAL_NUMBER_LENGTH = 16;
				this.m_oDeviceAdapters = Networking.GetAdapters ();
				this.m_strDeviceName = "";
				this.currentJob = "";
				this.objectExtensionVersion = "";
				this.m_strHeadSerialNumber = "";
				this.m_strFPGAFirmwareVersion = "";
				this.m_strApplicationVersion = "";
			}
			
			
			public SystemInfo (string pstrDeviceName, string headSerialNumber, string currentJob, uint stateCode, IPAddress remoteIP, string objectExtensionVersion, uint lastError)
			
			{
				this.stateCode = uint.MinValue;
				this.remoteIP = IPAddress.Parse ("0.0.0.0");
				this.lastError = uint.MinValue;
				this.LEC_SERIAL_NUMBER_LENGTH = 16;
				this.m_oDeviceAdapters = Networking.GetAdapters ();
				this.m_strDeviceName = "";
				this.currentJob = "";
				this.objectExtensionVersion = "";
				this.m_strHeadSerialNumber = "";
				this.m_strFPGAFirmwareVersion = "";
				this.m_strApplicationVersion = "";
				if (pstrDeviceName.Length > 0)
				{
					this.DeviceName = pstrDeviceName;
				}
				if (headSerialNumber.Length > 0)
				{
					this.HeadSerialNumber = headSerialNumber;
				}
				this.stateCode = stateCode;
				this.remoteIP = remoteIP;
				this.lastError = lastError;
				this.currentJob = currentJob;
				this.objectExtensionVersion = objectExtensionVersion;
			}
			
		#endregion
		
		#region Properties
		
			public string ApplicationVersion
			
			{
				get
				{
					string string1;
					FileVersionInfo fileVersionInfo1;
					Exception exception1;
					object[] objectArray1;
					LanmarkControls.CommonLib.General.Logging.Instance.Log (4, "SystemInfo.ApplicationVersion Property called()");
					try
					{
						if (this.m_strApplicationVersion.Length <= 0)
						{
							string1 = Path.GetDirectoryName (Assembly.GetExecutingAssembly ().GetName ().CodeBase);
							fileVersionInfo1 = FileVersionInfo.GetVersionInfo (Path.Combine (string1, "LocalMgr.exe"));
							objectArray1 = new object[] { fileVersionInfo1.ProductMajorPart, fileVersionInfo1.ProductMinorPart, fileVersionInfo1.ProductBuildPart, fileVersionInfo1.ProductPrivatePart };
							this.m_strApplicationVersion = string.Format ("{0}.{1}.{2}.{3}", objectArray1);
						}
						return this.m_strApplicationVersion;
					}
					catch (Exception exception2)
					{
						exception1 = exception2;
						LanmarkControls.CommonLib.General.Logging.Instance.Log (0, string.Format (("SystemInfo.ApplicationVersion Property - Exception error 0x03d " + exception1.Message), new object[0]));
						LanmarkControls.CommonLib.General.Logging.Instance.Log (0, exception1.ToString ());
					}
					return "";
				}
			}
			
			
			public byte[] Data
			
			{
				get
				{
					SysInfoData sysInfoData1;
					Exception exception1;
					try
					{
						sysInfoData1 = new SysInfoData ();
						sysInfoData1.FPGAFirmwareVersion = this.FPGAFirmwareVersion;
						sysInfoData1.ManufactureSerialNumber = this.SerialNumber;
						sysInfoData1.NodeMACAddress = this.DeviceMAC;
						sysInfoData1.FriendlyName = this.DeviceName;
						sysInfoData1.Address = this.DeviceIP;
						sysInfoData1.NetMask = this.DeviceMask;
						sysInfoData1.ApplicationVersion = this.ApplicationVersion;
						sysInfoData1.ObjectExtensionVersion = this.objectExtensionVersion;
						sysInfoData1.FreeTempStorage = this.TempStorageAvailable;
						sysInfoData1.FreePermStorage = this.PermStorageAvailable;
						sysInfoData1.FreeUSBStorage = this.USBStorageAvailable;
						sysInfoData1.PermStoragePath = CommonSvrUtil.PermFlashStoragePath;
						sysInfoData1.MarkHeadSerialNumber = this.HeadSerialNumber;
						sysInfoData1.TCPPortNumber = this.DevicePort;
						sysInfoData1.StateCode = this.stateCode;
						sysInfoData1.ConnectedAddress = this.remoteIP;
						sysInfoData1.LastError = this.lastError;
						sysInfoData1.ConnectedJobName = this.currentJob;
						return sysInfoData1.ToBytes ();
					}
					catch (Exception exception2)
					{
						exception1 = exception2;
						LanmarkControls.CommonLib.General.Logging.Instance.Log (0, string.Format (("SystemInfo.Data Property - Exception error 0x03d " + exception1.Message), new object[0]));
						LanmarkControls.CommonLib.General.Logging.Instance.Log (0, exception1.ToString ());
					}
					return null;
				}
			}
			
			
			public IPAddress DeviceIP
			
			{
				get
				{
					Exception exception1;
					LanmarkControls.CommonLib.General.Logging.Instance.Log (4, "SystemInfo.DeviceIP Property called()");
					try
					{
						if (this.m_oDeviceAdapters.Count != 0)
						{
							return IPAddress.Parse (this.m_oDeviceAdapters.Item (0).CurrentIpAddress);
						}
					}
					catch (Exception exception2)
					{
						exception1 = exception2;
						LanmarkControls.CommonLib.General.Logging.Instance.Log (0, string.Format (("SystemInfo.DeviceIP Property - Exception error 0x03d " + exception1.Message), new object[0]));
						LanmarkControls.CommonLib.General.Logging.Instance.Log (0, exception1.ToString ());
					}
					return IPAddress.Parse ("127.0.0.1");
				}
			}
			
			
			public string DeviceMAC
			
			{
				get
				{
					string string1;
					byte[] byteArray1;
					int i1;
					object[] objectArray1;
					Exception exception1;
					LanmarkControls.CommonLib.General.Logging.Instance.Log (4, "SystemInfo.DeviceMAC Property called()");
					try
					{
						byte[] byteArray2 = new byte[4];
						byteArray1 = new byte[6];
						i1 = 0;
						if (! DeviceDriver.KernelIoControl (this.IOCTL_HAL_GET_MAC_ADDRESS, ((byte[]) null), 0, byteArray1, byteArray1.Length, ref i1))
						{
							int i2 = Marshal.GetLastWin32Error ();
							return "";
						}
						else
						{
							objectArray1 = new object[] { ((int) byteArray1[0]), ((int) byteArray1[1]), ((int) byteArray1[2]), ((int) byteArray1[3]), ((int) byteArray1[4]), ((int) byteArray1[5]) };
							string1 = string.Format ("{0:x2}:{1:x2}:{2:x2}:{3:x2}:{4:x2}:{5:x2}", objectArray1);
							LanmarkControls.CommonLib.General.Logging.Instance.Log (8, ("SystemInfo.DeviceMAC: MAC Address 0x03d " + string1));
							return string1;
						}
					}
					catch (Exception exception2)
					{
						exception1 = exception2;
						LanmarkControls.CommonLib.General.Logging.Instance.Log (0, string.Format (("SystemInfo.DeviceMAC Property - Exception error 0x03d " + exception1.Message), new object[0]));
						LanmarkControls.CommonLib.General.Logging.Instance.Log (0, exception1.ToString ());
					}
					return "00:00:00:00:00:00";
				}
			}
			
			
			public IPAddress DeviceMask
			
			{
				get
				{
					Exception exception1;
					LanmarkControls.CommonLib.General.Logging.Instance.Log (4, "SystemInfo.DeviceMask Property called()");
					try
					{
						if (this.m_oDeviceAdapters.Count == 0)
						{
							return IPAddress.Parse ("255.255.255.255");
						}
						else
						{
							return IPAddress.Parse (this.m_oDeviceAdapters.Item (0).CurrentSubnetMask);
						}
					}
					catch (Exception exception2)
					{
						exception1 = exception2;
						LanmarkControls.CommonLib.General.Logging.Instance.Log (0, string.Format (("SystemInfo.DeviceMask Property - Exception error 0x03d " + exception1.Message), new object[0]));
						LanmarkControls.CommonLib.General.Logging.Instance.Log (0, exception1.ToString ());
					}
					return IPAddress.Parse ("255.255.255.255");
				}
			}
			
			
			public string DeviceName
			
			{
				get
				{
					Exception exception1;
					LanmarkControls.CommonLib.General.Logging.Instance.Log (4, "SystemInfo.DeviceName Property called()");
					try
					{
						if (this.m_strDeviceName.Length > 0)
						{
							return this.m_strDeviceName;
						}
						else
						{
							return Dns.GetHostName ();
						}
					}
					catch (Exception exception2)
					{
						exception1 = exception2;
						LanmarkControls.CommonLib.General.Logging.Instance.Log (0, string.Format (("SystemInfo.DeviceName Property - Exception error 0x03d " + exception1.Message), new object[0]));
						LanmarkControls.CommonLib.General.Logging.Instance.Log (0, exception1.ToString ());
					}
					return "";
				}
				set
				{
					this.m_strDeviceName = value;
				}
			}
			
			
			public ulong DevicePort
			
			{
				get
				{
					LanmarkControls.CommonLib.General.Logging.Instance.Log (4, "SystemInfo.DevicePort Property called()");
					return 12200;
				}
			}
			
			
			public string FPGAFirmwareVersion
			
			{
				get
				{
					Exception exception1;
					LanmarkControls.CommonLib.General.Logging.Instance.Log (4, "SystemInfo.FPGAFirmwareVersion Property called()");
					try
					{
						if (this.m_strFPGAFirmwareVersion.Length <= 0)
						{
							this.m_strFPGAFirmwareVersion = LECHAL.Instance.fpgaInterface.Version;
						}
						return this.m_strFPGAFirmwareVersion;
					}
					catch (Exception exception2)
					{
						exception1 = exception2;
						LanmarkControls.CommonLib.General.Logging.Instance.Log (0, string.Format (("SystemInfo.FPGAFirmwareVersion Property - Exception error 0x03d " + exception1.Message), new object[0]));
						LanmarkControls.CommonLib.General.Logging.Instance.Log (0, exception1.ToString ());
					}
					return "";
				}
			}
			
			
			public string HeadSerialNumber
			
			{
				get
				{
					LanmarkControls.CommonLib.General.Logging.Instance.Log (4, "SystemInfo.HeadSerialNumber Property called()");
					return this.m_strHeadSerialNumber;
				}
				set
				{
					this.m_strHeadSerialNumber = value;
				}
			}
			
			
			public int IOCTL_HAL_GET_MAC_ADDRESS
			
			{
				get
				{
					return DeviceDriver.CTL_CODE (257, 68, 0, 0);
				}
			}
			
			
			public int IOCTL_HAL_GET_SERIAL_NUMBER
			
			{
				get
				{
					return DeviceDriver.CTL_CODE (257, 70, 0, 0);
				}
			}
			
			
			public uint Opcode
			
			{
				get
				{
					return 1;
				}
			}
			
			
			public uint PermStorageAvailable
			
			{
				get
				{
					DiskMemoryProperties diskMemoryProperties1;
					Exception exception1;
					uint uInt32_1;
					LanmarkControls.CommonLib.General.Logging.Instance.Log (4, "SystemInfo.PermStorageAvailable Property called()");
					try
					{
						if (CommonSvrUtil.PermFlashStoragePath.Length == 0)
						{
							return uint.MinValue;
						}
						else if ((diskMemoryProperties1 = DiskSpace.FreeDiskSpace (CommonSvrUtil.PermFlashStoragePath)).readResult)
						{
							return Convert.ToUInt32 (Math.Abs (((long) (diskMemoryProperties1.FreeBytesAvailable / ((long) 1024)))));
						}
						else
						{
							uInt32_1 = uint.MinValue;
						}
					}
					catch (Exception exception2)
					{
						exception1 = exception2;
						LanmarkControls.CommonLib.General.Logging.Instance.Log (0, string.Format (("SystemInfo.PermStorageAvailable Property - Exception error 0x03d " + exception1.Message), new object[0]));
						LanmarkControls.CommonLib.General.Logging.Instance.Log (0, exception1.ToString ());
						uInt32_1 = uint.MinValue;
					}
					return uInt32_1;
				}
			}
			
			
			public string SerialNumber
			
			{
				get
				{
					byte[] byteArray1;
					int i1;
					int i2;
					Exception exception1;
					LanmarkControls.CommonLib.General.Logging.Instance.Log (4, "SystemInfo.SerialNumber Property called()");
					try
					{
						byte[] byteArray2 = new byte[4];
						byteArray1 = new byte[this.LEC_SERIAL_NUMBER_LENGTH];
						i1 = 0;
						if (! DeviceDriver.KernelIoControl (this.IOCTL_HAL_GET_SERIAL_NUMBER, ((byte[]) null), 0, byteArray1, byteArray1.Length, ref i1))
						{
							int i3 = Marshal.GetLastWin32Error ();
							return "";
						}
						else
						{
							i2 = ArrayEx.ValueLength (byteArray1, 0, byteArray1.Length, Encoding.ASCII);
							return Encoding.ASCII.GetString (byteArray1, 0, i2);
						}
					}
					catch (Exception exception2)
					{
						exception1 = exception2;
						LanmarkControls.CommonLib.General.Logging.Instance.Log (0, string.Format (("SystemInfo.SerialNumber Property - Exception error 0x03d " + exception1.Message), new object[0]));
						LanmarkControls.CommonLib.General.Logging.Instance.Log (0, exception1.ToString ());
					}
					return "";
				}
			}
			
			
			public uint TempStorageAvailable
			
			{
				get
				{
					Exception exception1;
					uint uInt32_1;
					LanmarkControls.CommonLib.General.Logging.Instance.Log (4, "SystemInfo.TempStorageAvailable Property called()");
					try
					{
						uInt32_1 = Convert.ToUInt32 (Math.Abs (((long) (((int) MemoryStatus.FreeRAMSpace ().AvailPhys) / 1024))));
					}
					catch (Exception exception2)
					{
						exception1 = exception2;
						LanmarkControls.CommonLib.General.Logging.Instance.Log (0, string.Format (("SystemInfo.TempStorageAvailable Property - Exception error 0x03d " + exception1.Message), new object[0]));
						LanmarkControls.CommonLib.General.Logging.Instance.Log (0, exception1.ToString ());
						uInt32_1 = uint.MinValue;
					}
					return uInt32_1;
				}
			}
			
			
			public uint USBStorageAvailable
			
			{
				get
				{
					DiskMemoryProperties diskMemoryProperties1;
					Exception exception1;
					uint uInt32_1;
					LanmarkControls.CommonLib.General.Logging.Instance.Log (4, "SystemInfo.USBStorageAvailable Property called()");
					try
					{
						if ((diskMemoryProperties1 = DiskSpace.FreeDiskSpace (CommonSvrUtil.PermUSBStoragePath)).readResult)
						{
							return Convert.ToUInt32 (Math.Abs (((long) (diskMemoryProperties1.FreeBytesAvailable / ((long) 1024)))));
						}
						else
						{
							uInt32_1 = uint.MinValue;
						}
					}
					catch (Exception exception2)
					{
						exception1 = exception2;
						LanmarkControls.CommonLib.General.Logging.Instance.Log (0, string.Format (("SystemInfo.USBStorageAvailable Property - Exception error 0x03d " + exception1.Message), new object[0]));
						LanmarkControls.CommonLib.General.Logging.Instance.Log (0, exception1.ToString ());
						uInt32_1 = uint.MinValue;
					}
					return uInt32_1;
				}
			}
			
		#endregion
	}
	
}

