//
// Decompiled with: Decompiler.NET, Version=2.0.0.230, Culture=neutral, PublicKeyToken=null, Version: 2.0.0.230
// Decompilation Started at: 14/02/2008 11:26:05
// Copyright 2003 - 2004, Jungle Creatures, Inc., All Rights Reserved. http://www.junglecreatures.com/
// Written by Jonathan Pierce, Email: support@junglecreatures.com
//

namespace LanmarkControls.LocalManager.Hosts

{
		
		#region Namespace Import Declarations
		
			using LanmarkControls.CommonLib.General;
			using LanmarkControls.CommonLib.Protocol;
			using LanmarkControls.CommonLib.Threading;
			using LanmarkControls.LECHardwareAbstraction.PInvoke;
			using LanmarkControls.LocalManager.Hosts.Utilities;
			using LanmarkControls.LocalManager;
			using System;
			using System.Threading;
			
		#endregion
		
	public class LANStreamHost : IHostControl
	
	{
		
		#region Fields
			private HostTypes hostInControl;
			private HostTypes hostType;
			private BaseThread m_oAliveThread;
			private BaseThread m_oDataThread;
			private BaseThread m_oEventThread;
			private BaseThread m_oPriorityThread;
			private bool maxMemReached;
			private Thread monitorEngineThread;
			public virtual event InputCommandHandler OnInputCommand;
			public virtual event UpdateClientInfoHandler OnUpdateClientInfo;
			private bool restartAllThreads;
			private bool stoppingEngine;
			private ManualResetEvent threadsResetEvent;
		#endregion
		
		#region Constructors
		
			public LANStreamHost ()
			
			{
				this.hostType = HostTypes.LANStream;
				this.m_oDataThread = ((BaseThread) null);
				this.m_oPriorityThread = ((BaseThread) null);
				this.m_oEventThread = ((BaseThread) null);
				this.m_oAliveThread = ((BaseThread) null);
				this.monitorEngineThread = ((Thread) null);
				this.restartAllThreads = false;
				this.threadsResetEvent = ((ManualResetEvent) null);
				this.maxMemReached = false;
				this.stoppingEngine = false;
				this.threadsResetEvent = new ManualResetEvent (false);
				this.MonitorEngineThread = new Thread (new ThreadStart (this.MonitorEngine));
				this.MonitorEngineThread.Priority = ThreadPriority.Normal;
				this.MonitorEngineThread.Start ();
			}
			
		#endregion
		
		#region Properties
		
			protected BaseThread AliveInst
			
			{
				get
				{
					return this.m_oAliveThread;
				}
				set
				{
					this.m_oAliveThread = value;
				}
			}
			
			
			protected BaseThread DataInst
			
			{
				get
				{
					return this.m_oDataThread;
				}
				set
				{
					this.m_oDataThread = value;
				}
			}
			
			
			protected BaseThread EventInst
			
			{
				get
				{
					return this.m_oEventThread;
				}
				set
				{
					this.m_oEventThread = value;
				}
			}
			
			
			public virtual HostTypes HostInControl
			
			{
				get
				{
					return this.hostInControl;
				}
				set
				{
					this.hostInControl = value;
				}
			}
			
			
			private bool MaxMemReached
			
			{
				get
				{
					return this.maxMemReached;
				}
				set
				{
					this.maxMemReached = value;
				}
			}
			
			
			private Thread MonitorEngineThread
			
			{
				get
				{
					return this.monitorEngineThread;
				}
				set
				{
					this.monitorEngineThread = value;
				}
			}
			
			
			protected BaseThread PriorityInst
			
			{
				get
				{
					return this.m_oPriorityThread;
				}
				set
				{
					this.m_oPriorityThread = value;
				}
			}
			
			
			private bool RestartAllThreads
			
			{
				get
				{
					return this.restartAllThreads;
				}
				set
				{
					this.restartAllThreads = value;
				}
			}
			
			
			private bool StoppingEngine
			
			{
				get
				{
					return this.stoppingEngine;
				}
				set
				{
					this.stoppingEngine = value;
				}
			}
			
			
			public virtual HostTypes ThisHostType
			
			{
				get
				{
					return this.hostType;
				}
			}
			
			
			private ManualResetEvent ThreadsResetEvent
			
			{
				get
				{
					return this.threadsResetEvent;
				}
				set
				{
					this.threadsResetEvent = value;
				}
			}
			
		#endregion
		
		#region Methods
		
			public virtual void AssumeControl ()
			
			{
				this.StartEngine ();
			}
			
			protected virtual void CreateAliveThread (bool pbLogConsole)
			
			{
				AliveThread aliveThread1 = ((AliveThread) null);
				if (this.AliveInst == null)
				{
					this.AliveInst = ((BaseThread) (aliveThread1 = new AliveThread ()));
				}
				else
				{
					aliveThread1 = (this.AliveInst as AliveThread);
				}
				aliveThread1.ConnectPort = ((uint) AdminSettings.AliveSettings.Port);
				aliveThread1.LogFile = AdminSettings.AliveSettings.LogFile;
				aliveThread1.LoggingLevel = AdminSettings.OtherSettings.LoggingLevel;
				aliveThread1.LogConsole = pbLogConsole;
			}
			
			protected virtual void CreateDataThread (bool pbLogConsole)
			
			{
				DataThread dataThread1 = ((DataThread) null);
				if (this.DataInst == null)
				{
					this.DataInst = ((BaseThread) (dataThread1 = new DataThread ()));
					dataThread1.OnUpdateClientInfo += new UpdateClientInfoHandler (this.OnUpdateClientInfo);
				}
				else
				{
					dataThread1 = (this.DataInst as DataThread);
				}
				dataThread1.ConnectPort = ((uint) AdminSettings.DataSettings.Port);
				dataThread1.LoggingLevel = AdminSettings.OtherSettings.LoggingLevel;
				dataThread1.LogConsole = pbLogConsole;
			}
			
			protected virtual void CreateEventThread (bool pbLogConsole)
			
			{
				DataThread dataThread1;
				PriorityThread priorityThread1;
				EventThread eventThread1 = ((EventThread) null);
				if (this.EventInst == null)
				{
					this.EventInst = ((BaseThread) (eventThread1 = new EventThread ()));
					if (this.DataInst != null)
					{
						dataThread1 = (this.m_oDataThread as DataThread);
						eventThread1.AbortCompleteNotify += new AbortCompleteEventHandler (dataThread1.AbortCompleteNotification);
						eventThread1.ExceptionMessageNotify += new ExceptionMessageEventHandler (dataThread1.ExceptionMessageNotification);
						dataThread1.MessagesNotify += new MessagesEventHandler (eventThread1.MessagesNotification);
					}
					if (this.PriorityInst != null)
					{
						priorityThread1 = (this.m_oPriorityThread as PriorityThread);
						priorityThread1.AbortNotify += new AbortEventHandler (eventThread1.AbortNotification);
					}
				}
				else
				{
					eventThread1 = (this.EventInst as EventThread);
				}
				eventThread1.ConnectPort = ((uint) AdminSettings.EventSettings.Port);
				eventThread1.LogFile = AdminSettings.EventSettings.LogFile;
				eventThread1.LoggingLevel = AdminSettings.OtherSettings.LoggingLevel;
				eventThread1.LogConsole = pbLogConsole;
			}
			
			protected virtual void CreatePriorityThread (bool pbLogConsole)
			
			{
				DataThread dataThread1;
				PriorityThread priorityThread1 = ((PriorityThread) null);
				if (this.PriorityInst == null)
				{
					this.PriorityInst = ((BaseThread) (priorityThread1 = new PriorityThread (this)));
					if (this.DataInst != null)
					{
						dataThread1 = (this.DataInst as DataThread);
						priorityThread1.AbortNotify += new AbortEventHandler (dataThread1.AbortNotification);
						priorityThread1.UpdateNotify += new UpdateEventHandler (dataThread1.UpdateNotification);
					}
				}
				else
				{
					priorityThread1 = (this.PriorityInst as PriorityThread);
				}
				priorityThread1.ConnectPort = ((uint) AdminSettings.PrioritySettings.Port);
				priorityThread1.LogFile = AdminSettings.PrioritySettings.LogFile;
				priorityThread1.LoggingLevel = AdminSettings.OtherSettings.LoggingLevel;
				priorityThread1.LogConsole = pbLogConsole;
			}
			
			public virtual void Disconnect ()
			
			{
			}
			
			public virtual bool Initialize ()
			
			{
				return false;
			}
			
			private void MonitorEngine ()
			
			{
				bool b1;
				while (this.ThreadsResetEvent.WaitOne ())
				{
					Logging.Instance.Log (2, MemoryStatus.StatusMessage);
					if (! this.MaxMemReached)
					{
						this.MaxMemReached = (! MemoryStatus.CalcDivision (25));
					}
					b1 = ((((this.m_oDataThread != null) && (! this.m_oDataThread.IsThreadRunning)) || (((this.m_oPriorityThread != null) && (! this.m_oPriorityThread.IsThreadRunning)) || ((this.m_oEventThread != null) && (! this.m_oEventThread.IsThreadRunning)))) || ((this.m_oAliveThread != null) && (! this.m_oAliveThread.IsThreadRunning)));
					if ((! this.StoppingEngine) && (b1 || this.RestartAllThreads))
					{
						bool b2 = this.ThreadsResetEvent.Reset ();
						this.ShutdownAllThreads ();
						this.StartEngine ();
					}
					Thread.Sleep (1000);
				}
			}
			
			private void ParseCommandLine (string[] args)
			
			{
				string string1;
				string string2;
				string string3;
				bool b1 = false;
				string[] stringArray1 = args;
				for (int i1 = 0; true; i1++)
				{
					if (i1 >= stringArray1.Length)
					{
						Logging.Instance.LogConsole = b1;
						Logging.Instance.Log (("LECStartup started at " + DateTime.Now.ToString ()));
						return;
					}
					string1 = stringArray1[i1];
					if (string1.StartsWith ("-") || string1.StartsWith ("/"))
					{
						string2 = string1.Remove (0, 1).ToLower ();
						if ((string3 = string2) != null)
						{
							string3 = string.IsInterned (string3);
							switch (string3)
							{
								case "j":
								
								{
										b1 = true;
										break;
								}
								default:
								
								{
										break;
								}
							}
						}
					}
				}
			}
			
			public virtual void ReleaseControl ()
			
			{
				this.StopEngine ();
			}
			
			public void RestartEngine ()
			
			{
				this.RestartAllThreads = true;
			}
			
			private void ShutdownAllThreads ()
			
			{
				if ((this.m_oPriorityThread != null) && this.m_oPriorityThread.IsThreadRunning)
				{
					Logging.Instance.Log ("Priority thread still running.  Abort...");
					bool b1 = this.m_oPriorityThread.StopThread ();
					Logging.Instance.Log ("The priority thread stopped.");
				}
				if ((this.m_oDataThread != null) && this.m_oDataThread.IsThreadRunning)
				{
					Logging.Instance.Log ("Data thread still running.  Abort...");
					bool b2 = this.m_oDataThread.StopThread ();
					Logging.Instance.Log ("The data thread stopped.");
				}
				if ((this.m_oEventThread != null) && this.m_oEventThread.IsThreadRunning)
				{
					Logging.Instance.Log ("Event thread still running.  Abort...");
					bool b3 = this.m_oEventThread.StopThread ();
					Logging.Instance.Log ("The event thread stopped.");
				}
				if ((this.m_oAliveThread != null) && this.m_oAliveThread.IsThreadRunning)
				{
					Logging.Instance.Log ("Alive thread still running.  Abort...");
					bool b4 = this.m_oAliveThread.StopThread ();
					Logging.Instance.Log ("The alive thread stopped.");
				}
				if (this.OnUpdateClientInfo != null)
				{
					this.OnUpdateClientInfo (ClientConnectionStatus.Startup, "", "0.0.0.0", 0);
				}
			}
			
			public void StartEngine ()
			
			{
				bool b1;
				int i1;
				Exception exception1;
				Exception exception2;
				Exception exception3;
				Exception exception4;
				Exception exception5;
				try
				{
					bool b6 = this.ThreadsResetEvent.Reset ();
					this.RestartAllThreads = false;
					this.StoppingEngine = false;
					Logging.Instance.LoggingLevel = AdminSettings.OtherSettings.LoggingLevel;
					Logging.Instance.Log (("JobEngine started at " + DateTime.Now.ToString ()));
					Logging.Instance.Log (("Jobengine initial memory status: " + MemoryStatus.StatusMessage));
					this.MaxMemReached = (! MemoryStatus.CalcDivision (25));
					Logging.Instance.Log (("Jobengine after expansion: " + MemoryStatus.StatusMessage));
					if (! this.MaxMemReached)
					{
						this.MaxMemReached = (! MemoryStatus.CalcDivision (25));
						Logging.Instance.Log (6, MemoryStatus.StatusMessage);
					}
					this.CreateDataThread (Logging.Instance.LogConsole);
					this.CreatePriorityThread (Logging.Instance.LogConsole);
					this.CreateEventThread (Logging.Instance.LogConsole);
					this.CreateAliveThread (Logging.Instance.LogConsole);
					if (! this.MaxMemReached)
					{
						this.MaxMemReached = (! MemoryStatus.CalcDivision (25));
						Logging.Instance.Log (6, MemoryStatus.StatusMessage);
					}
					i1 = 0;
					
				L_0126:
					
					{
					}
					b1 = true;
					try
					{
						if (b1 && (this.m_oEventThread != null))
						{
							if (! this.m_oEventThread.StartThread ())
							{
								Logging.Instance.Log ("The event thread failed to start.");
								b1 = false;
							}
							else
							{
								Logging.Instance.Log ("The event thread is started.");
							}
						}
					}
					catch (Exception exception6)
					{
						exception1 = exception6;
						Logging.Instance.Log (0, "Exception thrown while trying to start Event Thread.  Skipping...");
						Logging.Instance.Log (0, exception1.ToString ());
						b1 = false;
					}
					if (! this.MaxMemReached)
					{
						this.MaxMemReached = (! MemoryStatus.CalcDivision (25));
						Logging.Instance.Log (6, MemoryStatus.StatusMessage);
					}
					try
					{
						if (b1 && (this.m_oPriorityThread != null))
						{
							if (! this.m_oPriorityThread.StartThread ())
							{
								Logging.Instance.Log ("The priority thread failed to start.");
								b1 = false;
							}
							else
							{
								Logging.Instance.Log ("The priority thread is started.");
							}
						}
					}
					catch (Exception exception7)
					{
						exception2 = exception7;
						Logging.Instance.Log (0, "Exception thrown while trying to start Priority Thread.  Skipping...");
						Logging.Instance.Log (0, exception2.ToString ());
						b1 = false;
					}
					if (! this.MaxMemReached)
					{
						this.MaxMemReached = (! MemoryStatus.CalcDivision (25));
						Logging.Instance.Log (6, MemoryStatus.StatusMessage);
					}
					try
					{
						if (b1 && (this.m_oAliveThread != null))
						{
							if (! this.m_oAliveThread.StartThread ())
							{
								Logging.Instance.Log ("The alive thread failed to start.");
								b1 = false;
							}
							else
							{
								Logging.Instance.Log ("The alive thread is started.");
							}
						}
					}
					catch (Exception exception8)
					{
						exception3 = exception8;
						Logging.Instance.Log (0, "Exception thrown while trying to start Alive Thread.  Skipping...");
						Logging.Instance.Log (0, exception3.ToString ());
						b1 = false;
					}
					if (! this.MaxMemReached)
					{
						this.MaxMemReached = (! MemoryStatus.CalcDivision (25));
						Logging.Instance.Log (6, MemoryStatus.StatusMessage);
					}
					try
					{
						if (b1 && (this.m_oDataThread != null))
						{
							if (! this.m_oDataThread.StartThread ())
							{
								Logging.Instance.Log ("The data thread failed to start.");
								b1 = false;
							}
							else
							{
								Logging.Instance.Log ("The data thread is started.");
							}
						}
					}
					catch (Exception exception9)
					{
						exception4 = exception9;
						Logging.Instance.Log (0, "Exception thrown while trying to start Data Thread.  Skipping...");
						Logging.Instance.Log (0, exception4.ToString ());
						b1 = false;
					}
					if (! this.MaxMemReached)
					{
						this.MaxMemReached = (! MemoryStatus.CalcDivision (25));
						Logging.Instance.Log (6, MemoryStatus.StatusMessage);
					}
					i1++;
					if ((! b1) && (i1 == 5))
					{
						Logging.Instance.Log ("Failed to initially start all threads.  Abort.");
						this.ShutdownAllThreads ();
						return;
					}
					else if (! b1)
					{
						goto L_0126;
					}
					else
					{
						bool b7 = this.ThreadsResetEvent.Set ();
					}
				}
				catch (Exception exception10)
				{
					exception5 = exception10;
					Logging.Instance.Log (0, ("ATTENTION: An exception was thrown - " + exception5.Message));
					Logging.Instance.Log (0, exception5.ToString ());
				}
			}
			
			public virtual void StartHostAPI ()
			
			{
			}
			
			public void StopEngine ()
			
			{
				this.StoppingEngine = true;
				bool b1 = this.ThreadsResetEvent.Reset ();
				this.ShutdownAllThreads ();
				GC.Collect ();
				GC.WaitForPendingFinalizers ();
			}
			
		#endregion
	}
	
}

