//
// Decompiled with: Decompiler.NET, Version=2.0.0.230, Culture=neutral, PublicKeyToken=null, Version: 2.0.0.230
// Decompilation Started at: 14/02/2008 11:26:05
// Copyright 2003 - 2004, Jungle Creatures, Inc., All Rights Reserved. http://www.junglecreatures.com/
// Written by Jonathan Pierce, Email: support@junglecreatures.com
//

namespace LanmarkControls.LocalManager.Hosts.Utilities

{
		
		#region Namespace Import Declarations
		
			using LanmarkControls.CommonLib.Extension;
			using LanmarkControls.CommonLib.General;
			using LanmarkControls.CommonLib.Protocol;
			using LanmarkControls.CommonLib.Threading;
			using System.Net;
			using System.Net.Sockets;
			using System;
			using System.Runtime.InteropServices;
			using System.Threading;
			using Logging = LanmarkControls.CommonLib.General.Logging;
			
		#endregion
		
	public class BaseTransmitThread : BaseThread
	
	{
		
		#region Fields
			private bool m_bAbort;
			private bool m_bSendResponseAck;
			private int m_iMaxBufferSize;
			private IPAddress m_ipConnectAddress;
			private TcpListener m_oListen;
			private uint m_uiConnectPort;
			private Socket oConnect;
			private IPEndPoint oEnd;
		#endregion
		
		#region Constructors
		
			public BaseTransmitThread ()
			
			{
				this.m_bAbort = false;
				this.oConnect = ((Socket) null);
				this.oEnd = ((IPEndPoint) null);
				this.m_iMaxBufferSize = 0;
				this.m_ipConnectAddress = IPAddress.Parse ("127.0.0.1");
				this.m_uiConnectPort = 12200;
				this.m_bSendResponseAck = false;
			}
			
		#endregion
		
		#region Properties
		
			protected bool AbortThisThread
			
			{
				get
				{
					return this.m_bAbort;
				}
				set
				{
					this.m_bAbort = value;
				}
			}
			
			
			public IPAddress ConnectAddress
			
			{
				get
				{
					return this.m_ipConnectAddress;
				}
				set
				{
					this.m_ipConnectAddress = value;
				}
			}
			
			
			public bool Connected
			
			{
				get
				{
					return (this.oConnect != null);
				}
			}
			
			
			public uint ConnectPort
			
			{
				get
				{
					return this.m_uiConnectPort;
				}
				set
				{
					this.m_uiConnectPort = value;
				}
			}
			
			
			protected int MaxBufferSize
			
			{
				get
				{
					return this.m_iMaxBufferSize;
				}
				set
				{
					this.m_iMaxBufferSize = value;
				}
			}
			
			
			protected bool SendResponseAck
			
			{
				get
				{
					return this.m_bSendResponseAck;
				}
				set
				{
					this.m_bSendResponseAck = value;
				}
			}
			
		#endregion
		
		#region Methods
		
			protected virtual bool Action (uint puiOpcode, byte[] pbyteData, out int piDataSent)
			
			{
				piDataSent = 0;
				return true;
			}
			
			protected virtual bool Action (uint puiOpcode, byte[] pbyteData)
			
			{
				int i1 = 0;
				return this.Action (puiOpcode, pbyteData, out i1);
			}
			
			protected virtual void ConnectionEstablished (IPAddress pipAddress)
			
			{
				Logging.Instance.Log (4, (this.ToString () + ".BaseTransmitThread.ConnectionEstablished() called."));
			}
			
			protected virtual bool ConnectionLost (IPAddress pipAddress)
			
			{
				Logging.Instance.Log (4, (this.ToString () + ".BaseTransmitThread.ConnectionLost() called."));
				return true;
			}
			
			protected virtual void ConnectionWait ()
			
			{
			}
			
			protected override bool ExecuteWorkThread ()
			
			{
				int i1;
				byte[] byteArray1;
				SocketException socketException1;
				int i2;
				TransmitPacket transmitPacket1;
				int i3;
				int i4;
				byte[] byteArray2;
				int i5;
				byte[] byteArray3;
				Exception exception1;
				byte[] byteArray4;
				Logging.Instance.Log (4, (this.ToString () + ".BaseTransmitThread.ExecuteWorkThread() called."));
				try
				{
					i1 = 0;
					if (! this.Connected)
					{
						if (this.m_oListen == null)
						{
							Logging.Instance.Log (4, (this.ToString () + ".BaseTransmitThread.ExecuteWorkThread() - Bad listen object!"));
						}
						while (! this.m_oListen.Pending ())
						{
							if (i1 == 0)
							{
								Logging.Instance.Log (4, (this.ToString () + ".BaseTransmitThread.ExecuteWorkThread() - Listening for connection."));
							}
							if (i1++ == 2500)
							{
								i1 = 0;
							}
							if (this.AbortThisThread)
							{
								return false;
							}
							else
							{
								this.ConnectionWait ();
								Thread.Sleep (0);
							}
						}
						Logging.Instance.Log (4, (this.ToString () + ".BaseTransmitThread.ExecuteWorkThread() - Accepting Socket."));
						this.oConnect = this.m_oListen.AcceptSocket ();
						if (this.oConnect == null)
						{
							return false;
						}
						else
						{
							this.oConnect.SetSocketOption (SocketOptionLevel.Socket, SocketOptionName.DontLinger, 1);
							this.oConnect.SetSocketOption (SocketOptionLevel.Tcp, SocketOptionName.IPOptions, 1);
							this.m_oListen.Stop ();
							this.oEnd = (this.oConnect.RemoteEndPoint as IPEndPoint);
							this.ConnectionEstablished (this.oEnd.Address);
						}
					}
					while (! this.AbortThisThread)
					{
						byteArray1 = new byte[TransmitPacket.FixedPacketSize];
						i1 = 0;
						try
						{
							while (this.oConnect.Available == 0)
							{
								if (i1 == 0)
								{
									Logging.Instance.Log (4, (this.ToString () + ".BaseTransmitThread.ExecuteWorkThread() - Listening for data."));
								}
								if (i1++ == 2500)
								{
									i1 = 0;
								}
								if (this.AbortThisThread)
								{
									break;
								}
								else
								{
									this.PerformActionWhileWaiting ();
									Thread.Sleep (1);
								}
							}
						}
						catch (SocketException socketException2)
						{
							socketException1 = socketException2;
							Logging.Instance.Log (0, string.Format ((this.ToString () + ".BaseTransmitThread.ExecuteWorkThread() - Socket Exception error 0x03d " + socketException1.Message), new object[0]));
							Logging.Instance.Log (0, socketException1.ToString ());
						}
						if ((! this.AbortThisThread) && (this.oConnect.Available < 0))
						{
							this.AbortThisThread = true;
						}
						if (! this.AbortThisThread)
						{
							Logging.Instance.Log (4, (this.ToString () + ".BaseTransmitThread.ExecuteWorkThread() - Connection available."));
							i2 = this.oConnect.Receive (byteArray1, byteArray1.Length, SocketFlags.None);
							transmitPacket1 = new TransmitPacket (byteArray1);
							if (transmitPacket1.Opcode <= uint.MinValue)
							{
								this.AbortThisThread = true;
								continue;
							}
							Logging.Instance.Log (4, (this.ToString () + ".BaseTransmitThread.ExecuteWorkThread() - Opcode match found."));
							i3 = 0;
							i4 = this.MaxBufferSize;
							if ((i4 == 0) || (((uint) i4) > transmitPacket1.DataSize))
							{
								i4 = ((int) transmitPacket1.DataSize);
							}
							byteArray2 = ArrayEx.Create (i4);
							while ((transmitPacket1.DataSize > uint.MinValue) && (! this.AbortThisThread))
							{
								if (((long) transmitPacket1.DataSize) < ((long) byteArray2.Length))
								{
									byteArray2 = ArrayEx.Resize (byteArray2, ((int) (((int) transmitPacket1.DataSize) + i3)), i3);
								}
								while (i3 != byteArray2.Length)
								{
									i2 = this.oConnect.Receive (byteArray2, i3, ((int) (byteArray2.Length - i3)), SocketFlags.None);
									Logging.Instance.LogBytes (8, byteArray2, i3, i2);
									transmitPacket1.DataSize = ((uint) (((int) transmitPacket1.DataSize) - i2));
									i3 += i2;
									Logging.Instance.Log (4, (this.ToString () + ".BaseTransmitThread.ExecuteWorkThread() - received " + i2.ToString () + " bytes."));
								}
								bool b3 = this.Action (transmitPacket1.Opcode, byteArray2, out i5);
								i3 = 0;
								if (byteArray2.Length != i5)
								{
									Array.Copy (((Array) byteArray2), i5, ((Array) byteArray2), 0, ((int) (byteArray2.Length - i5)));
									i3 = (byteArray2.Length - i5);
								}
							}
							if (! this.SendResponseAck)
							{
								Logging.Instance.Log (4, (this.ToString () + ".BaseTransmitThread.ExecuteWorkThread() - ACK disabled."));
								continue;
							}
							Logging.Instance.Log (4, (this.ToString () + ".BaseTransmitThread.ExecuteWorkThread() - Attempting to send ACK..."));
							byteArray4 = new byte[4];
							byteArray3 = byteArray4;
							int i6 = this.oConnect.Send (byteArray3);
							Logging.Instance.Log (4, (this.ToString () + ".BaseTransmitThread.ExecuteWorkThread() - ACK sent."));
						}
					}
				}
				catch (Exception exception2)
				{
					exception1 = exception2;
					Logging.Instance.Log (0, string.Format ((this.ToString () + ".BaseTransmitThread.ExecuteWorkThread() - Exception error 0x03d " + exception1.Message), new object[0]));
					Logging.Instance.Log (0, exception1.ToString ());
				}
				if (this.AbortThisThread)
				{
					Logging.Instance.Log ((this.ToString () + ".BaseTransmitThread.ExecuteWorkThread() - Abort detected."));
				}
				bool b1 = true;
				if (this.oEnd != null)
				{
					b1 = this.ConnectionLost (this.oEnd.Address);
				}
				if ((this.oConnect != null) && b1)
				{
					this.oConnect.Shutdown (SocketShutdown.Both);
					this.oConnect.Close ();
					this.oConnect = ((Socket) null);
					this.oEnd = ((IPEndPoint) null);
					Logging.Instance.Log ((this.ToString () + ".BaseTransmitThread.ExecuteWorkThread() - Connection shutdown."));
				}
				return false;
			}
			
			protected override bool InitializeWorkThread ()
			
			{
				SocketException socketException1;
				Logging.Instance.Log (4, (this.ToString () + ".BaseTransmitThread.InitializeWorkThread() called."));
				this.AbortThisThread = false;
				try
				{
					this.m_oListen = new TcpListener (((int) this.m_uiConnectPort));
					this.m_oListen.Start ();
					Logging.Instance.Log (4, (this.ToString () + ".BaseTransmitThread.InitializeWorkThread() - TcpListener started."));
				}
				catch (SocketException socketException2)
				{
					socketException1 = socketException2;
					Logging.Instance.Log (0, (this.ToString () + ".BaseTransmitThread.InitializeWorkThread() - Socket exception thrown."));
					Logging.Instance.Log (0, socketException1.ToString ());
					this.m_oListen = ((TcpListener) null);
					return false;
				}
				return base.InitializeWorkThread ();
			}
			
			protected virtual void PerformActionWhileWaiting ()
			
			{
			}
			
			protected override bool TerminateWorkThread ()
			
			{
				Exception exception1;
				Logging.Instance.Log (4, (this.ToString () + ".BaseTransmitThread.TerminateWorkThread() called."));
				try
				{
					if (this.oConnect != null)
					{
						this.oConnect.Shutdown (SocketShutdown.Both);
						this.oConnect.Close ();
						this.oConnect = ((Socket) null);
						this.oEnd = ((IPEndPoint) null);
						Logging.Instance.Log ((this.ToString () + ".BaseTransmitThread.TerminateWorkThread() - Connection shutdown."));
					}
					if (this.m_oListen != null)
					{
						this.m_oListen.Stop ();
					}
				}
				catch (Exception exception2)
				{
					exception1 = exception2;
					Logging.Instance.Log (0, (this.ToString () + ".BaseTransmitThread.TerminateWorkThread() - Exception thrown."));
					Logging.Instance.Log (0, exception1.ToString ());
				}
				this.m_oListen = ((TcpListener) null);
				return base.TerminateWorkThread ();
			}
			
		#endregion
	}
	
}

