//
// Decompiled with: Decompiler.NET, Version=2.0.0.230, Culture=neutral, PublicKeyToken=null, Version: 2.0.0.230
// Decompilation Started at: 14/02/2008 11:26:05
// Copyright 2003 - 2004, Jungle Creatures, Inc., All Rights Reserved. http://www.junglecreatures.com/
// Written by Jonathan Pierce, Email: support@junglecreatures.com
//

namespace LanmarkControls.LocalManager.Hosts.Utilities

{
		
		#region Namespace Import Declarations
		
			using LanmarkControls.CommonLib.General;
			using LanmarkControls.CommonLib.Protocol;
			using LanmarkControls.CommonLib.Threading;
			using LanmarkControls.LECEngine;
			using LanmarkControls.LECHardwareAbstraction;
			using LanmarkControls.LocalManager.Hosts;
			using System;
			using System.Collections;
			using System.Runtime.InteropServices;
			
		#endregion
		
	public class PriorityThread : BaseTransmitThread
	
	{
		
		#region Fields
			public event AbortEventHandler AbortNotify;
			private bool m_bRestart;
			private LANStreamHost streamHost;
			public event UpdateEventHandler UpdateNotify;
		#endregion
		
		#region Constructors
		
			public PriorityThread (LANStreamHost lanStreamHost)
			
			{
				this.streamHost = ((LANStreamHost) null);
				this.m_bRestart = false;
				this.streamHost = lanStreamHost;
			}
			
		#endregion
		
		#region Properties
		
			public bool Restart
			
			{
				get
				{
					return this.m_bRestart;
				}
				set
				{
					this.m_bRestart = value;
				}
			}
			
			
			private LANStreamHost StreamHost
			
			{
				get
				{
					return this.streamHost;
				}
			}
			
		#endregion
		
		#region Methods
		
			protected override bool Action (uint puiOpcode, byte[] pbyteData, out int piDataSent)
			
			{
				AtAbortReader atAbortReader1;
				AbortEventArgs abortEventArgs1;
				AtUpdateReader atUpdateReader1;
				UpdateEventArgs updateEventArgs1;
				AtInterlocksReader atInterlocksReader1;
				Logging.Instance.Log (4, "PriorityThread.Action() called.");
				piDataSent = 0;
				base.SendResponseAck = false;
				if (puiOpcode != 3)
				{
					return false;
				}
				int i1 = BitConverter.ToInt32 (pbyteData, 0);
				if (i1 == AtAbortReader.ID)
				{
					atAbortReader1 = new AtAbortReader (pbyteData);
					piDataSent = pbyteData.Length;
					if (atAbortReader1.Reason == AbortReason.Job)
					{
						Logging.Instance.Log (4, "PriorityThread.Action() - received Abort - Reason.Job.  ACK enabled.");
						base.SendResponseAck = true;
						if (this.AbortNotify != null)
						{
							abortEventArgs1 = new AbortEventArgs (atAbortReader1.Reason);
							this.AbortNotify (this, abortEventArgs1);
						}
						return true;
					}
					else if (atAbortReader1.Reason != AbortReason.Terminate)
					{
						return true;
					}
					else
					{
						Logging.Instance.Log (4, "PriorityThread.Action() - received Abort - Reason.Terminate.  ACK disabled.");
						this.StreamHost.RestartEngine ();
						return false;
					}
				}
				if (i1 == AtSuspendReader.ID)
				{
					Logging.Instance.Log (4, "PriorityThread.Action() - received Suspend req.  ACK disabled.");
					piDataSent = pbyteData.Length;
					return LECHAL.Instance.SuspendJob ();
				}
				else if (i1 == AtResumeReader.ID)
				{
					Logging.Instance.Log (4, "PriorityThread.Action() - received Resume req.  ACK disabled.");
					piDataSent = pbyteData.Length;
					return LECHAL.Instance.ResumeJob ();
				}
				else if (i1 == AtUpdateReader.ID)
				{
					Logging.Instance.Log (4, "PriorityThread.Action() - received Update.  ACK disabled.");
					atUpdateReader1 = new AtUpdateReader (pbyteData);
					piDataSent = pbyteData.Length;
					if (this.UpdateNotify != null)
					{
						updateEventArgs1 = new UpdateEventArgs (atUpdateReader1.FileNames, atUpdateReader1.AdditionalInfo);
						this.UpdateNotify (this, updateEventArgs1);
					}
					return true;
				}
				else if (i1 == AtRegistersReader.ID)
				{
					Logging.Instance.Log (4, "PriorityThread.Action() - received Registers req.  ACK disabled.");
					LECHAL.Instance.DoGetRegisters = true;
					piDataSent = pbyteData.Length;
					return true;
				}
				else if (i1 == AtInterlocksReader.ID)
				{
					Logging.Instance.Log (4, "PriorityThread.Action() - received Registers req.  ACK disabled.");
					atInterlocksReader1 = new AtInterlocksReader (pbyteData);
					piDataSent = pbyteData.Length;
					bool b1 = LECHAL.Instance.SetInterlockEnable (atInterlocksReader1.Config);
					return true;
				}
				else if (i1 != AtRestartReader.ID)
				{
					return false;
				}
				else
				{
					Logging.Instance.Log (4, "PriorityThread.Action() - received Restart req.  ACK disabled.");
					piDataSent = pbyteData.Length;
					JobOpStatus jobOpStatus1 = LECJobEngine.Instance.AbortJob ();
					LECHAL.Instance.ResetBoard ();
					return true;
				}
			}
			
			protected override void InterruptWorkThread (bool pbAbort)
			
			{
				Logging.Instance.Log (4, "PriorityThread.InterruptWorkThread() called.");
				base.AbortThisThread = pbAbort;
				base.InterruptWorkThread (pbAbort);
			}
			
			protected override void PerformActionWhileWaiting ()
			
			{
				Exception exception1;
				try
				{
					base.PerformActionWhileWaiting ();
				}
				catch (Exception exception2)
				{
					exception1 = exception2;
					Logging.Instance.Log (0, string.Format (("PriorityThread.ActionWait() - Exception error 0x03d " + exception1.Message), new object[0]));
					Logging.Instance.Log (0, exception1.ToString ());
				}
			}
			
		#endregion
	}
	
}

