//
// Decompiled with: Decompiler.NET, Version=2.0.0.230, Culture=neutral, PublicKeyToken=null, Version: 2.0.0.230
// Decompilation Started at: 14/02/2008 11:26:05
// Copyright 2003 - 2004, Jungle Creatures, Inc., All Rights Reserved. http://www.junglecreatures.com/
// Written by Jonathan Pierce, Email: support@junglecreatures.com
//

namespace LanmarkControls.LocalManager.Pendants

{
		
		#region Namespace Import Declarations
		
			using LanmarkControls.LECHardwareAbstraction.SerialPortInterface;
			using LanmarkControls.LECHardwareAbstraction.Utilities;
			using LanmarkControls.LocalManager;
			using System;
			using System.Text;
			using System.Threading;
			
		#endregion
		
	public class QTERMJ10Pendant : IPendant
	
	{
		
		#region Fields
			private byte backspaceKey;
			private byte[] beepSequence;
			private byte[] carriageReturnSequence;
			private byte characterCache;
			private byte[] clearScreenSequence;
			private Port COM1Port;
			private byte d0Key;
			private byte d1Key;
			private byte d2Key;
			private byte d3Key;
			private byte d4Key;
			private byte d9Key;
			private byte[] deleteCharSequence;
			private byte deleteKey;
			private byte downKey;
			private byte enterKey;
			private byte escapeKey;
			private byte[] hideCursorSequence;
			private Timer IdleTimer;
			private byte leftKey;
			private uint m_uiIdleTimeout;
			private byte minusKey;
			private ManualResetEvent NewCharacterEvent;
			public virtual event InputIdleHandler OnInputIdle;
			public virtual event InputValueHandler OnInputValue;
			private byte periodKey;
			private bool processingCommand;
			private byte rightKey;
			private char selectedLineCharacter;
			private byte[] showEditCursorSequence;
			private byte tabKey;
			private byte upKey;
			private int writeDelay;
		#endregion
		
		#region Constructors
		
			public QTERMJ10Pendant ()
			
			{
				byte[] byteArray1 = new byte[] { 27, 69 };
				this.clearScreenSequence = byteArray1;
				byteArray1 = new byte[] { 13 };
				this.carriageReturnSequence = byteArray1;
				this.selectedLineCharacter = '~';
				byteArray1 = new byte[] { 127 };
				this.deleteCharSequence = byteArray1;
				byteArray1 = new byte[] { 7 };
				this.beepSequence = byteArray1;
				this.showEditCursorSequence = new byte[] { 27, 98, 65 };
				this.hideCursorSequence = new byte[] { 27, 98, 64 };
				this.upKey = 97;
				this.downKey = 98;
				this.rightKey = 99;
				this.leftKey = 100;
				this.d0Key = 48;
				this.d1Key = 49;
				this.d2Key = 50;
				this.d3Key = 51;
				this.d4Key = 52;
				this.d9Key = 57;
				this.escapeKey = 27;
				this.enterKey = 13;
				this.deleteKey = 127;
				this.backspaceKey = 8;
				this.tabKey = 99;
				this.periodKey = 46;
				this.minusKey = 45;
				this.COM1Port = ((Port) null);
				this.m_uiIdleTimeout = 1;
				this.writeDelay = 3;
				this.characterCache = byte.MinValue;
				this.processingCommand = false;
				this.IdleTimer = ((Timer) null);
			}
			
		#endregion
		
		#region Properties
		
			public virtual byte BackspaceKey
			
			{
				get
				{
					return this.backspaceKey;
				}
			}
			
			
			public virtual byte[] BeepSequence
			
			{
				get
				{
					return this.beepSequence;
				}
			}
			
			
			public virtual byte[] CarriageReturnSequence
			
			{
				get
				{
					return this.carriageReturnSequence;
				}
			}
			
			
			private byte CharacterCache
			
			{
				get
				{
					return this.characterCache;
				}
				set
				{
					this.characterCache = value;
				}
			}
			
			
			public virtual byte[] ClearScreenSequence
			
			{
				get
				{
					return this.clearScreenSequence;
				}
			}
			
			
			public virtual byte D0Key
			
			{
				get
				{
					return this.d0Key;
				}
			}
			
			
			public virtual byte D1Key
			
			{
				get
				{
					return this.d1Key;
				}
			}
			
			
			public virtual byte D2Key
			
			{
				get
				{
					return this.d2Key;
				}
			}
			
			
			public virtual byte D3Key
			
			{
				get
				{
					return this.d3Key;
				}
			}
			
			
			public virtual byte D4Key
			
			{
				get
				{
					return this.d4Key;
				}
			}
			
			
			public virtual byte D9Key
			
			{
				get
				{
					return this.d9Key;
				}
			}
			
			
			public virtual byte[] DeleteCharSequence
			
			{
				get
				{
					return this.deleteCharSequence;
				}
			}
			
			
			public virtual byte DeleteKey
			
			{
				get
				{
					return this.deleteKey;
				}
			}
			
			
			public virtual byte DownKey
			
			{
				get
				{
					return this.downKey;
				}
			}
			
			
			public virtual byte EnterKey
			
			{
				get
				{
					return this.enterKey;
				}
			}
			
			
			public virtual byte EscapeKey
			
			{
				get
				{
					return this.escapeKey;
				}
			}
			
			
			public virtual byte[] HideCursorSequence
			
			{
				get
				{
					return this.hideCursorSequence;
				}
			}
			
			
			public virtual uint IdleTimeout
			
			{
				get
				{
					return this.m_uiIdleTimeout;
				}
				set
				{
					this.m_uiIdleTimeout = value;
				}
			}
			
			
			public virtual byte LeftKey
			
			{
				get
				{
					return this.leftKey;
				}
			}
			
			
			public virtual byte MinusKey
			
			{
				get
				{
					return this.minusKey;
				}
			}
			
			
			public virtual byte PeriodKey
			
			{
				get
				{
					return this.periodKey;
				}
			}
			
			
			private bool ProcessingCommand
			
			{
				get
				{
					return this.processingCommand;
				}
				set
				{
					this.processingCommand = value;
				}
			}
			
			
			public virtual byte RightKey
			
			{
				get
				{
					return this.rightKey;
				}
			}
			
			
			public virtual char SelectedLineCharacter
			
			{
				get
				{
					return this.selectedLineCharacter;
				}
			}
			
			
			public virtual byte[] ShowEditCursorSequence
			
			{
				get
				{
					return this.showEditCursorSequence;
				}
			}
			
			
			public virtual byte TabKey
			
			{
				get
				{
					return this.tabKey;
				}
			}
			
			
			public virtual byte UpKey
			
			{
				get
				{
					return this.upKey;
				}
			}
			
			
			public int WriteDelay
			
			{
				get
				{
					return this.writeDelay;
				}
			}
			
		#endregion
		
		#region Methods
		
			public virtual void Beep ()
			
			{
				this.COM1Port.Output = this.BeepSequence;
				Thread.Sleep (this.WriteDelay);
			}
			
			public virtual void ClearScreen ()
			
			{
				this.COM1Port.Output = this.ClearScreenSequence;
				Thread.Sleep (this.WriteDelay);
			}
			
			public virtual bool Connect ()
			
			{
				DetailedPortSettings detailedPortSettings1 = ((DetailedPortSettings) new HandshakeNone ());
				detailedPortSettings1.BasicSettings.BaudRate = BaudRates.CBR_19200;
				this.COM1Port = new Port ("COM1:", detailedPortSettings1);
				if (this.COM1Port == null)
				{
					return false;
				}
				this.COM1Port.RThreshold = 1;
				this.COM1Port.InputLen = 1;
				this.COM1Port.SThreshold = 1;
				this.COM1Port.DataReceived += new Port.CommEvent (this.OnDataReceived);
				this.NewCharacterEvent = new ManualResetEvent (false);
				Thread thread1 = new Thread (new ThreadStart (this.ProcessCharacterLoop));
				thread1.Priority = ThreadPriority.Normal;
				thread1.Start ();
				bool b1 = this.COM1Port.Open ();
				if (b1)
				{
					this.InitializePendant ();
				}
				return b1;
			}
			
			public virtual bool Disconnect ()
			
			{
				if (this.IdleTimer != null)
				{
					this.IdleTimer.Dispose ();
					this.IdleTimer = ((Timer) null);
				}
				return this.COM1Port.Close ();
			}
			
			public virtual void IdleTimeoutCallback (object stateInfo)
			
			{
				if (this.IdleTimer != null)
				{
					bool b1 = this.IdleTimer.Change (-1L, ((long) (((int) this.IdleTimeout) * 1000)));
				}
				if (this.OnInputIdle != null)
				{
					this.OnInputIdle ("");
				}
				if (this.IdleTimer != null)
				{
					bool b2 = this.IdleTimer.Change (((uint) (((int) this.IdleTimeout) * 1000)), ((uint) (((int) this.IdleTimeout) * 1000)));
				}
			}
			
			private void InitializePendant ()
			
			{
				byte[] byteArray1 = new byte[] { 27, 108, 64 };
				this.Write (byteArray1);
				byte[] byteArray2 = new byte[] { 27, 82, 64 };
				this.Write (byteArray2);
				byte[] byteArray3 = new byte[] { 27, 83, 64 };
				this.Write (byteArray3);
				byte[] byteArray4 = new byte[] { 27, 99, 64 };
				this.Write (byteArray4);
				byte[] byteArray5 = new byte[] { 27, 97, 66 };
				this.Write (byteArray5);
				byte[] byteArray8 = new byte[] { 27, 105 };
				byte[] byteArray6 = byteArray8;
				this.Write (byteArray6);
				this.ClearScreen ();
				byte[] byteArray7 = new byte[] { 27, 86, 65 };
				this.Write (byteArray7);
				this.Write (this.BeepSequence);
				this.WriteLine ("Lanmark Controls Inc");
				Thread.Sleep (200);
				this.WriteLine ("Initializing...");
				Thread.Sleep (200);
				this.WriteLine ("MENU: 2.3");
				Thread.Sleep (200);
				SystemInfo systemInfo1 = new SystemInfo ();
				this.WriteLine (("SW:   " + systemInfo1.ApplicationVersion));
			}
			
			public virtual bool IsTextCharacter (byte testCharacter)
			
			{
				if ((testCharacter >= 65) && (testCharacter <= 90))
				{
					return true;
				}
				else if ((testCharacter >= 40) && (testCharacter <= 57))
				{
					return true;
				}
				else if (testCharacter != 32)
				{
					return false;
				}
				else
				{
					return true;
				}
			}
			
			private void OnDataReceived ()
			
			{
				if ((this.IdleTimer != null) && (this.IdleTimer != null))
				{
					bool b1 = this.IdleTimer.Change (-1L, ((long) (((int) this.IdleTimeout) * 1000)));
				}
				byte[] byteArray1 = this.COM1Port.Input;
				if (! this.ProcessingCommand)
				{
					this.CharacterCache = byteArray1[0];
					bool b2 = this.NewCharacterEvent.Set ();
				}
				if (this.IdleTimer != null)
				{
					bool b3 = this.IdleTimer.Change (((uint) (((int) this.IdleTimeout) * 1000)), ((uint) (((int) this.IdleTimeout) * 1000)));
				}
			}
			
			private void ProcessCharacterLoop ()
			
			{
				while (true)
				{
					bool b1 = this.NewCharacterEvent.WaitOne ();
					if (this.OnInputValue == null)
					{
						continue;
					}
					this.ProcessingCommand = true;
					this.OnInputValue (this.CharacterCache);
					this.CharacterCache = byte.MinValue;
					this.ProcessingCommand = false;
					bool b2 = this.NewCharacterEvent.Reset ();
				}
			}
			
			public virtual byte[] SetCursorPositionSequence (uint puiRow, uint puiColumn)
			
			{
				return new byte[] { 27, 73, ((byte) (puiRow + 64)), ((byte) (puiColumn + 64)) };
			}
			
			public virtual void StartIdleTimer ()
			
			{
				TimerCallback timerCallback1 = new TimerCallback (this.IdleTimeoutCallback);
				this.IdleTimer = new Timer (timerCallback1, this, ((uint) (((int) this.IdleTimeout) * 1000)), ((uint) (((int) this.IdleTimeout) * 1000)));
			}
			
			public virtual void Write (string pstrLine)
			
			{
				byte[] byteArray1 = new ASCIIEncoding ().GetBytes (pstrLine);
				this.COM1Port.Output = byteArray1;
				Thread.Sleep (this.WriteDelay);
			}
			
			public virtual void Write (byte[] pbyteLine)
			
			{
				this.COM1Port.Output = pbyteLine;
				Thread.Sleep (this.WriteDelay);
			}
			
			public virtual void WriteLine (string pstrLine)
			
			{
				this.Write (pstrLine);
				this.WriteLine ();
			}
			
			public virtual void WriteLine ()
			
			{
				this.COM1Port.Output = this.CarriageReturnSequence;
				Thread.Sleep (this.WriteDelay);
			}
			
		#endregion
	}
	
}

