//
// Decompiled with: Decompiler.NET, Version=2.0.0.230, Culture=neutral, PublicKeyToken=null, Version: 2.0.0.230
// Decompilation Started at: 14/02/2008 11:06:55
// Copyright 2003 - 2004, Jungle Creatures, Inc., All Rights Reserved. http://www.junglecreatures.com/
// Written by Jonathan Pierce, Email: support@junglecreatures.com
//

namespace De.Mud.Telnet

{
		
		#region Namespace Import Declarations
		
			using System.Drawing;
			using System;
			using System.Text;
			
		#endregion
		
	public abstract class TelnetProtocolHandler
	
	{
		
		#region Fields
			private byte[] cr;
			private byte[] crlf;
			private byte current_sb;
			private const byte DO = 253;
			private const byte DONT = 254;
			private const byte EOR = 239;
			private const byte IAC = byte.MaxValue;
			private static byte[] IACDO;
			private static byte[] IACDONT;
			private static byte[] IACSB;
			private static byte[] IACSE;
			private static byte[] IACWILL;
			private static byte[] IACWONT;
			private byte neg_state;
			private byte[] receivedDX;
			private byte[] receivedWX;
			private const byte SB = 250;
			private const byte SE = 240;
			private byte[] sentDX;
			private byte[] sentWX;
			private const byte STATE_DATA = byte.MinValue;
			private const byte STATE_IAC = 1;
			private const byte STATE_IACDO = 4;
			private const byte STATE_IACDONT = 6;
			private const byte STATE_IACSB = 2;
			private const byte STATE_IACSBDATA = 8;
			private const byte STATE_IACSBDATAIAC = 9;
			private const byte STATE_IACSBIAC = 7;
			private const byte STATE_IACWILL = 3;
			private const byte STATE_IACWONT = 5;
			private const byte TELOPT_BINARY = byte.MinValue;
			private const byte TELOPT_ECHO = 1;
			private const byte TELOPT_EOR = 25;
			private const byte TELOPT_NAWS = 31;
			private const byte TELOPT_SGA = 3;
			private const byte TELOPT_TTYPE = 24;
			private static byte TELQUAL_IS;
			private static byte TELQUAL_SEND;
			private byte[] tempbuf;
			protected string terminalType;
			private const byte WILL = 251;
			protected Size windowSize;
			private const byte WONT = 252;
		#endregion
		
		#region Constructors
		
			public TelnetProtocolHandler ()
			
			{
				this.tempbuf = new byte[0];
				this.crlf = new byte[2];
				this.cr = new byte[2];
				this.terminalType = "dumb";
				this.windowSize = Size.Empty;
				this.Reset ();
				this.crlf[0] = 13;
				this.crlf[1] = 10;
				this.cr[0] = 13;
				this.cr[1] = byte.MinValue;
			}
			
			
			static TelnetProtocolHandler ()
			
			{
				byte[] byteArray1 = new byte[] { byte.MaxValue, 251 };
				TelnetProtocolHandler.IACWILL = byteArray1;
				byte[] byteArray2 = new byte[] { byte.MaxValue, 252 };
				TelnetProtocolHandler.IACWONT = byteArray2;
				byte[] byteArray3 = new byte[] { byte.MaxValue, 253 };
				TelnetProtocolHandler.IACDO = byteArray3;
				byte[] byteArray4 = new byte[] { byte.MaxValue, 254 };
				TelnetProtocolHandler.IACDONT = byteArray4;
				byte[] byteArray5 = new byte[] { byte.MaxValue, 250 };
				TelnetProtocolHandler.IACSB = byteArray5;
				byte[] byteArray6 = new byte[] { byte.MaxValue, 240 };
				TelnetProtocolHandler.IACSE = byteArray6;
				TelnetProtocolHandler.TELQUAL_IS = byte.MinValue;
				TelnetProtocolHandler.TELQUAL_SEND = 1;
			}
			
		#endregion
		
		#region Properties
		
			public string CR
			
			{
				get
				{
					return Encoding.ASCII.GetString (this.cr);
				}
				set
				{
					this.cr = Encoding.ASCII.GetBytes (value);
				}
			}
			
			
			public string CRLF
			
			{
				get
				{
					return Encoding.ASCII.GetString (this.crlf);
				}
				set
				{
					this.crlf = Encoding.ASCII.GetBytes (value);
				}
			}
			
		#endregion
		
		#region Methods
		
			private void HandleSB (byte type, byte[] sbdata, int sbcount)
			
			{
				if (((type == 24) && (sbcount > 0)) && (sbdata[0] == TelnetProtocolHandler.TELQUAL_SEND))
				{
					this.Write (TelnetProtocolHandler.IACSB);
					this.Write (24);
					this.Write (TelnetProtocolHandler.TELQUAL_IS);
					this.Write (Encoding.ASCII.GetBytes (this.terminalType));
					this.Write (TelnetProtocolHandler.IACSE);
				}
			}
			
			protected void InputFeed (byte[] b, int len)
			
			{
				byte[] byteArray1 = new byte[(this.tempbuf.Length + len)];
				Array.Copy (((Array) this.tempbuf), 0, ((Array) byteArray1), 0, this.tempbuf.Length);
				Array.Copy (((Array) b), 0, ((Array) byteArray1), this.tempbuf.Length, len);
				this.tempbuf = byteArray1;
			}
			
			protected int Negotiate (byte[] nbuf)
			
			{
				int i1;
				byte[] byteArray1;
				byte[] byteArray2;
				byte[] byteArray3;
				byte byte1;
				byte byte2;
				int i2;
				int i3;
				int i4;
				bool b1;
				bool b2;
				Size size1;
				int i5;
				int i6;
				int i7;
				byte[] byteArray4;
				byte byte3;
				byte byte4;
				byte byte5;
				byte byte6;
				byte byte7;
				byte byte8;
				byte byte11;
				i1 = this.tempbuf.Length;
				if (i1 == 0)
				{
					return -1;
				}
				byteArray1 = new byte[3];
				byteArray2 = new byte[this.tempbuf.Length];
				byteArray3 = this.tempbuf;
				i2 = 0;
				i3 = 0;
				i4 = 0;
				b1 = false;
				b2 = false;
				goto L_0773;
				
			L_01B7:
				
				{
				}
				byte2 = 254;
				
			L_01BE:
				
				{
				}
				if ((byte2 != this.sentDX[(((int) byte1) + 128)]) || (251 != this.receivedWX[(((int) byte1) + 128)]))
				{
					byteArray1[0] = byte.MaxValue;
					byteArray1[1] = byte2;
					byteArray1[2] = byte1;
					this.Write (byteArray1);
					this.sentDX[(((int) byte1) + 128)] = byte2;
					this.receivedWX[(((int) byte1) + 128)] = 251;
				}
				this.neg_state = byte.MinValue;
				goto L_0773;
				
			L_027F:
				
				{
				}
				byte2 = 254;
				
			L_0286:
				
				{
				}
				if ((byte2 != this.sentDX[(((int) byte1) + 128)]) || (252 != this.receivedWX[(((int) byte1) + 128)]))
				{
					byteArray1[0] = byte.MaxValue;
					byteArray1[1] = byte2;
					byteArray1[2] = byte1;
					this.Write (byteArray1);
					this.sentDX[(((int) byte1) + 128)] = byte2;
					this.receivedWX[(((int) byte1) + 128)] = 251;
				}
				this.neg_state = byte.MinValue;
				goto L_0773;
				
			L_0471:
				
				{
				}
				byte2 = 252;
				
			L_0478:
				
				{
				}
				if ((byte2 != this.sentWX[(128 + ((int) byte1))]) || (253 != this.receivedDX[(128 + ((int) byte1))]))
				{
					byteArray1[0] = byte.MaxValue;
					byteArray1[1] = byte2;
					byteArray1[2] = byte1;
					this.Write (byteArray1);
					this.sentWX[(((int) byte1) + 128)] = byte2;
					this.receivedDX[(((int) byte1) + 128)] = 253;
				}
				this.neg_state = byte.MinValue;
				goto L_0773;
				
			L_0539:
				
				{
				}
				byte2 = 252;
				
			L_0540:
				
				{
				}
				if ((byte2 != this.sentWX[(((int) byte1) + 128)]) || (254 != this.receivedDX[(((int) byte1) + 128)]))
				{
					byteArray1[0] = byte.MaxValue;
					byteArray1[1] = byte2;
					byteArray1[2] = byte1;
					this.Write (byteArray1);
					this.sentWX[(((int) byte1) + 128)] = byte2;
					this.receivedDX[(((int) byte1) + 128)] = 254;
				}
				this.neg_state = byte.MinValue;
				
			L_0773:
				
				{
				}
				while ((! b1) && ((i3 < i1) && (i4 < nbuf.Length)))
				{
					byte1 = byteArray3[i3++];
					if (byte1 >= 128)
					{
						byte1 = ((byte) (((int) byte1) - 256));
					}
					byte3 = this.neg_state;
					switch (byte3)
					{
						case byte.MinValue:
						
						{
								if (byte1 != byte.MaxValue)
								{
									nbuf[i4++] = byte1;
									continue;
								}
								this.neg_state = 1;
								continue;
						}
						case 1:
						
						{
								byte4 = byte1;
								if (byte4 == 239)
								{
									this.NotifyEndOfRecord ();
									this.neg_state = byte.MinValue;
									continue;
								}
								switch ((int) byte4)
								{
									case 250:
									
									{
											this.neg_state = 2;
											i2 = 0;
											continue;
									}
									case 251:
									
									{
											this.neg_state = 3;
											continue;
									}
									case 252:
									
									{
											this.neg_state = 5;
											continue;
									}
									case 253:
									
									{
											this.neg_state = 4;
											continue;
									}
									case 254:
									
									{
											this.neg_state = 6;
											continue;
									}
									case 255:
									
									{
											this.neg_state = byte.MinValue;
											nbuf[i4++] = byte.MaxValue;
											continue;
									}
								}
								this.neg_state = byte.MinValue;
								continue;
						}
						case 2:
						
						{
								for (i6 = i3; (i6 < this.tempbuf.Length); i6++)
								{
									if (this.tempbuf[i6] == 240)
									{
										b2 = true;
									}
								}
								if (! b2)
								{
									i3--;
									b1 = true;
									continue;
								}
								b2 = false;
								if (byte1 != byte.MaxValue)
								{
									this.current_sb = byte1;
									i2 = 0;
									this.neg_state = 8;
									continue;
								}
								this.neg_state = 7;
								continue;
						}
						case 3:
						
						{
								byte5 = byte1;
								switch (byte5)
								{
									case byte.MinValue:
									
									{
											byte2 = 253;
											goto L_01BE;
									}
									case 1:
									
									{
											byte2 = 253;
											this.SetLocalEcho (false);
											goto L_01BE;
									}
									case 2:
									
									{
											goto L_01B7;
									}
									case 3:
									
									{
											byte2 = 253;
											goto L_01BE;
									}
								}
								if (byte5 == 25)
								{
									byte2 = 253;
									goto L_01BE;
								}
								else
								{
									goto L_01B7;
								}
						}
						case 4:
						
						{
								byte7 = byte1;
								switch (byte7)
								{
									case byte.MinValue:
									
									{
											byte2 = 251;
											goto L_0478;
									}
									case 1:
									
									{
											byte2 = 251;
											this.SetLocalEcho (true);
											goto L_0478;
									}
									case 2:
									
									{
											goto L_0471;
									}
									case 3:
									
									{
											byte2 = 251;
											goto L_0478;
									}
								}
								if (byte7 == 24)
								{
									byte2 = 251;
									goto L_0478;
								}
								else if (byte7 == 31)
								{
									size1 = this.windowSize;
									this.receivedDX[((int) byte1)] = 253;
									if (size1.GetType () == typeof (Size))
									{
										byte2 = 251;
										this.sentWX[((int) byte1)] = 251;
										byteArray1[0] = byte.MaxValue;
										byteArray1[1] = 251;
										byteArray1[2] = 31;
										this.Write (byteArray1);
										this.Write (byte.MaxValue);
										this.Write (250);
										this.Write (31);
										this.Write (((byte) (size1.Width >> 8)));
										this.Write (((byte) (size1.Width & 255)));
										this.Write (((byte) (size1.Height >> 8)));
										this.Write (((byte) (size1.Height & 255)));
										this.Write (byte.MaxValue);
										this.Write (240);
										goto L_0478;
									}
									this.Write (byte.MaxValue);
									this.Write (252);
									this.Write (31);
									byte2 = 252;
									this.sentWX[((int) byte1)] = 252;
									goto L_0478;
								}
								else
								{
									goto L_0471;
								}
						}
						case 5:
						
						{
								byte6 = byte1;
								switch (byte6)
								{
									case byte.MinValue:
									
									{
											byte2 = 254;
											goto L_0286;
									}
									case 1:
									
									{
											this.SetLocalEcho (true);
											byte2 = 254;
											goto L_0286;
									}
									case 2:
									
									{
											goto L_027F;
									}
									case 3:
									
									{
											byte2 = 254;
											goto L_0286;
									}
								}
								if (byte6 == 25)
								{
									byte2 = 254;
									goto L_0286;
								}
								else
								{
									goto L_027F;
								}
						}
						case 6:
						
						{
								byte8 = byte1;
								switch (byte8)
								{
									case byte.MinValue:
									
									{
											byte2 = 252;
											goto L_0540;
									}
									case 1:
									
									{
											byte2 = 252;
											this.SetLocalEcho (false);
											goto L_0540;
									}
									case 2:
									
									{
											goto L_0539;
									}
									case 3:
									
									{
											byte2 = 252;
											goto L_0540;
									}
								}
								if (byte8 == 31)
								{
									byte2 = 252;
									goto L_0540;
								}
								else
								{
									goto L_0539;
								}
						}
						case 7:
						
						{
								for (i5 = i3; (i5 < this.tempbuf.Length); i5++)
								{
									if (this.tempbuf[i5] == 240)
									{
										b2 = true;
									}
								}
								if (! b2)
								{
									i3--;
									b1 = true;
									continue;
								}
								b2 = false;
								if (byte1 != byte.MaxValue)
								{
									this.neg_state = byte.MinValue;
									continue;
								}
								i2 = 0;
								this.current_sb = byte1;
								this.neg_state = 8;
								continue;
						}
						case 8:
						
						{
								for (i7 = i3; (i7 < this.tempbuf.Length); i7++)
								{
									if (this.tempbuf[i7] == 240)
									{
										b2 = true;
									}
								}
								if (! b2)
								{
									i3--;
									b1 = true;
									continue;
								}
								b2 = false;
								if (byte1 != byte.MaxValue)
								{
									byteArray2[i2++] = byte1;
									continue;
								}
								this.neg_state = 9;
								continue;
						}
						case 9:
						
						{
								byte11 = byte1;
								if (byte11 == 240)
								{
									this.HandleSB (this.current_sb, byteArray2, i2);
									this.current_sb = byte.MinValue;
									this.neg_state = byte.MinValue;
									continue;
								}
								if (byte11 == 250)
								{
									this.HandleSB (this.current_sb, byteArray2, i2);
									this.neg_state = 2;
									continue;
								}
								if (byte11 != byte.MaxValue)
								{
									this.neg_state = byte.MinValue;
									continue;
								}
								this.neg_state = 8;
								byteArray2[i2++] = byte.MaxValue;
								continue;
						}
					}
					this.neg_state = byte.MinValue;
				}
				byteArray4 = new byte[(i1 - i3)];
				Array.Copy (((Array) this.tempbuf), i3, ((Array) byteArray4), 0, ((int) (i1 - i3)));
				this.tempbuf = byteArray4;
				return i4;
			}
			
			protected abstract void NotifyEndOfRecord ();
			protected void Reset ()
			
			{
				this.neg_state = byte.MinValue;
				this.receivedDX = new byte[256];
				this.sentDX = new byte[256];
				this.receivedWX = new byte[256];
				this.sentWX = new byte[256];
			}
			
			protected void SendTelnetControl (byte code)
			
			{
				byte[] byteArray1 = new byte[] { byte.MaxValue, code };
				this.Write (byteArray1);
			}
			
			protected abstract void SetLocalEcho (bool echo);
			protected void Transpose (byte[] buf)
			
			{
				byte[] byteArray2;
				int i3;
				int i4;
				byte byte1;
				int i2 = 0;
				byte[] byteArray1 = new byte[(buf.Length * 2)];
				for (int i1 = 0; true; i1++)
				{
					if (i1 >= buf.Length)
					{
						byteArray2 = new byte[i2];
						Array.Copy (((Array) byteArray1), 0, ((Array) byteArray2), 0, i2);
						this.Write (byteArray2);
						return;
					}
					byte1 = buf[i1];
					if (byte1 == 10)
					{
						if (this.receivedDX[128] == 253)
						{
							byteArray1[i2++] = buf[i1];
						}
						else
						{
							while ((byteArray1.Length - i2) < this.crlf.Length)
							{
								byteArray2 = new byte[(byteArray1.Length * 2)];
								Array.Copy (((Array) byteArray1), 0, ((Array) byteArray2), 0, i2);
								byteArray1 = byteArray2;
							}
							for (i3 = 0; (i3 < this.crlf.Length); i3++)
							{
								byteArray1[i2++] = this.crlf[i3];
							}
						}
					}
					else if (byte1 == 13)
					{
						if (this.receivedDX[128] == 253)
						{
							byteArray1[i2++] = buf[i1];
						}
						else
						{
							while ((byteArray1.Length - i2) < this.cr.Length)
							{
								byteArray2 = new byte[(byteArray1.Length * 2)];
								Array.Copy (((Array) byteArray1), 0, ((Array) byteArray2), 0, i2);
								byteArray1 = byteArray2;
							}
							for (i4 = 0; (i4 < this.cr.Length); i4++)
							{
								byteArray1[i2++] = this.cr[i4];
							}
						}
					}
					else if (byte1 != byte.MaxValue)
					{
						byteArray1[i2++] = buf[i1];
					}
					else
					{
						byteArray1[i2++] = byte.MaxValue;
						byteArray1[i2++] = byte.MaxValue;
					}
				}
			}
			
			protected abstract void Write (byte[] b);
			private void Write (byte b)
			
			{
				byte[] byteArray1 = new byte[] { b };
				this.Write (byteArray1);
			}
			
		#endregion
	}
	
}

