//
// Decompiled with: Decompiler.NET, Version=2.0.0.230, Culture=neutral, PublicKeyToken=null, Version: 2.0.0.230
// Decompilation Started at: 14/02/2008 11:06:55
// Copyright 2003 - 2004, Jungle Creatures, Inc., All Rights Reserved. http://www.junglecreatures.com/
// Written by Jonathan Pierce, Email: support@junglecreatures.com
//

namespace De.Mud.Telnet

{
		
		#region Namespace Import Declarations
		
			using Net.Graphite.Telnet;
			using System.Drawing;
			using System.Net;
			using System.Net.Sockets;
			using System;
			using System.Text;
			using System.Threading;
			
		#endregion
		
	public class TelnetWrapper : TelnetProtocolHandler
	
	{
		
		#region Fields
			private ManualResetEvent connectDone;
			public event DataAvailableEventHandler DataAvailable;
			public event DisconnectedEventHandler Disconnected;
			protected string hostname;
			protected int port;
			private ManualResetEvent sendDone;
			private Socket socket;
		#endregion
		
		#region Constructors
		
			public TelnetWrapper ()
			
			{
				this.connectDone = new ManualResetEvent (false);
				this.sendDone = new ManualResetEvent (false);
			}
			
		#endregion
		
		#region Properties
		
			public bool Connected
			
			{
				get
				{
					return this.socket.Connected;
				}
			}
			
			
			public string Hostname
			
			{
				set
				{
					this.hostname = value;
				}
			}
			
			
			public int Port
			
			{
				set
				{
					if (value > 0)
					{
						this.port = value;
					}
					else
					{
						throw new ArgumentException ("Port number must be greater than 0.", "Port");
					}
				}
			}
			
			
			public int TerminalHeight
			
			{
				set
				{
					base.windowSize.Height = value;
				}
			}
			
			
			public string TerminalType
			
			{
				set
				{
					base.terminalType = value;
				}
			}
			
			
			public int TerminalWidth
			
			{
				set
				{
					base.windowSize.Width = value;
				}
			}
			
		#endregion
		
		#region Methods
		
			public void Close ()
			
			{
				this.Dispose ();
			}
			
			public void Connect (string host, int port)
			
			{
				IPHostEntry iPHostEntry1;
				IPAddress iPAddress1;
				IPEndPoint iPEndPoint1;
				try
				{
					iPHostEntry1 = Dns.Resolve (host);
					iPAddress1 = iPHostEntry1.AddressList[0];
					iPEndPoint1 = new IPEndPoint (iPAddress1, port);
					this.socket = new Socket (AddressFamily.InterNetwork, SocketType.Stream, ProtocolType.Tcp);
					IAsyncResult iAsyncResult1 = this.socket.BeginConnect (((EndPoint) iPEndPoint1), new AsyncCallback (this.ConnectCallback), this.socket);
					bool b1 = this.connectDone.WaitOne ();
					base.Reset ();
				}
				catch
				{
					this.Disconnect ();
					throw;
				}
			}
			
			public void Connect ()
			
			{
				this.Connect (this.hostname, this.port);
			}
			
			private void ConnectCallback (IAsyncResult ar)
			
			{
				Exception exception1;
				Socket socket1 = ((Socket) null);
				try
				{
					socket1 = ((Socket) ar.AsyncState);
					socket1.EndConnect (ar);
					bool b1 = this.connectDone.Set ();
				}
				catch (Exception exception2)
				{
					exception1 = exception2;
					this.Disconnect ();
					throw new ApplicationException (("Unable to connect to " + socket1.RemoteEndPoint.ToString ()), exception1);
				}
			}
			
			public void Disconnect ()
			
			{
				if ((this.socket != null) && this.socket.Connected)
				{
					this.socket.Shutdown (SocketShutdown.Both);
					this.socket.Close ();
					this.Disconnected (this, new EventArgs ());
				}
			}
			
			public void Dispose ()
			
			{
				GC.SuppressFinalize (this);
				this.Dispose (true);
			}
			
			protected void Dispose (bool disposing)
			
			{
				if (disposing)
				{
					this.Disconnect ();
				}
			}
			
			~TelnetWrapper ()
			
			{
				this.Dispose (false);
			}
			
			protected override void NotifyEndOfRecord ()
			
			{
			}
			
			private void Receive (Socket client)
			
			{
				State state1;
				Exception exception1;
				try
				{
					state1 = new State ();
					state1.WorkSocket = client;
					IAsyncResult iAsyncResult1 = client.BeginReceive (state1.Buffer, 0, 256, SocketFlags.None, new AsyncCallback (this.ReceiveCallback), state1);
				}
				catch (Exception exception2)
				{
					exception1 = exception2;
					this.Disconnect ();
					throw new ApplicationException ("Error on read from socket.", exception1);
				}
			}
			
			public void Receive ()
			
			{
				this.Receive (this.socket);
			}
			
			private void ReceiveCallback (IAsyncResult ar)
			
			{
				State state1;
				Socket socket1;
				int i1;
				Exception exception1;
				try
				{
					state1 = ((State) ar.AsyncState);
					socket1 = state1.WorkSocket;
					i1 = socket1.EndReceive (ar);
					if (i1 > 0)
					{
						base.InputFeed (state1.Buffer, i1);
						int i2 = base.Negotiate (state1.Buffer);
						this.DataAvailable (this, new DataAvailableEventArgs (Encoding.ASCII.GetString (state1.Buffer, 0, i1)));
						IAsyncResult iAsyncResult1 = socket1.BeginReceive (state1.Buffer, 0, 256, SocketFlags.None, new AsyncCallback (this.ReceiveCallback), state1);
					}
					else
					{
						this.Disconnect ();
					}
				}
				catch (Exception exception2)
				{
					exception1 = exception2;
					this.Disconnect ();
					throw new ApplicationException ("Error reading from socket.", exception1);
				}
			}
			
			public string Send (string cmd)
			
			{
				byte[] byteArray1;
				Exception exception1;
				string string1;
				try
				{
					byteArray1 = Encoding.ASCII.GetBytes (cmd);
					base.Transpose (byteArray1);
					string1 = ((string) null);
				}
				catch (Exception exception2)
				{
					exception1 = exception2;
					this.Disconnect ();
					throw new ApplicationException ("Error writing to socket.", exception1);
				}
				return string1;
			}
			
			private void Send (Socket client, byte[] byteData)
			
			{
				IAsyncResult iAsyncResult1 = client.BeginSend (byteData, 0, byteData.Length, SocketFlags.None, new AsyncCallback (this.SendCallback), client);
			}
			
			private void SendCallback (IAsyncResult ar)
			
			{
				Socket socket1 = ((Socket) ar.AsyncState);
				int i1 = socket1.EndSend (ar);
				bool b1 = this.sendDone.Set ();
			}
			
			protected override void SetLocalEcho (bool echo)
			
			{
			}
			
			protected override void Write (byte[] b)
			
			{
				if (this.socket.Connected)
				{
					this.Send (this.socket, b);
				}
				bool b1 = this.sendDone.WaitOne ();
			}
			
		#endregion
	}
	
}

